
-- #########################################################
-- #########################################################
-- ConfigEnv.sql
-- #########################################################
-- #########################################################

SPOOL spool.txt
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

-- #########################################################
-- #########################################################
-- VersionCheck.sql
-- #########################################################
-- #########################################################

declare
  curMajor number;
  curMinor number;
  apos number;
  npos number;
  verOk number;
  curVer varchar2(20);
  tstVer varchar2(20);
  aver varchar2(80);
begin
  aver := '14.20.00'; /*    ! */
  verOk := 0;
  select max(Major) into curMajor from DatabaseVersion;
  select max(Minor) into curMinor from DatabaseVersion where Major = curMajor;
  curVer := curMajor;
  apos := LENGTH(curVer) - 1;
  curVer := SUBSTR(curVer, 1, (apos - 1)) || '.' || SUBSTR(curVer, apos, 2) || '.' || TO_CHAR(curMinor, 'FM00');

  apos := 1;
  npos := 0;
  while ((verOk = 0) and (npos < LENGTH(aver))) loop
    npos := INSTR(aver, ',', apos);
    if (npos = 0) then
      npos := LENGTH(aver) + 1;
    end if;
    tstVer := SUBSTR(aver, apos, npos - apos);
    apos := npos + 1;
    if (SUBSTR(curVer, 1, LENGTH(tstVer)) = tstVer) then
      verOk := 1;
    end if;
  end loop;
  
  if (verOk = 0 ) then
    raise_application_error(-20000, '  [' || curVer || ']    ['|| aver ||']');
  end if;
  
end;
/

-- #########################################################
-- #########################################################
-- Alter_RegProjectResult1430.sql
-- #########################################################
-- #########################################################

/*        14.30 */
-- CREATE TRIGGER TR_RegProjectResult_BI_0
CREATE OR REPLACE TRIGGER TR_REGPROJECTRESULT_BI
  BEFORE INSERT
  ON REGPROJECTRESULT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_RegProjectResult_BI_0)
-- Version 14.30.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then
    :new.BudgetRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_RegProjectResult_BI_500)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_RegProjectResult_BU_0
CREATE OR REPLACE TRIGGER TR_REGPROJECTRESULT_BU
  BEFORE UPDATE
  ON REGPROJECTRESULT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_RegProjectResult_BU_0)
-- Version 14.30.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;

END;
/
/*        */
ALTER TABLE RegProjectResult ADD (
  ResultTypeTmp NUMBER(10),
    CHECK((ResultTypeTmp<=2147483647)AND(ResultTypeTmp>-2147483648)),
  ResultKindTmp NUMBER(10),
    CHECK((ResultKindTmp<=2147483647)AND(ResultKindTmp>-2147483648)),
  ResultCode VARCHAR2(4000),/*   ??    */
  Note VARCHAR2(4000)/*  */
)
/
commit work
/
/*     */
update RegProjectResult set
  ResultTypeTmp = ResultType,
  ResultKindTmp = ResultKind
/
  
commit work
/
/*    */
ALTER TABLE RegProjectResult DROP (ResultType)
/
ALTER TABLE RegProjectResult DROP (ResultKind)
/
commit work
/
/*      */
ALTER TABLE RegProjectResult ADD (
  ResultType VARCHAR2(4000),
  ResultKind VARCHAR2(4000)
)
/
commit work
/
/*        */
update RegProjectResult rr set
    ResultType = (select Max(name) from enumvalues where (enumref in (select id from enums where Name = '')) and (val = rr.ResultTypeTmp)),
    ResultKind = (select Max(name) from enumvalues where (enumref in (select id from enums where Name = '')) and (val = rr.ResultKindTmp))
/
commit work
/
/*    */
ALTER TABLE RegProjectResult DROP (ResultTypeTmp)
/
ALTER TABLE RegProjectResult DROP (ResultKindTmp)
/
commit work
/
ALTER TABLE InvestObject ADD (
  FederalName VARCHAR2(2000)/*    . */
)
/
commit work
/
ALTER TABLE RegProjectResult MODIFY(ResultCode NOT NULL)
/
ALTER TABLE RegProjectResult MODIFY(ResultType NOT NULL)
/
ALTER TABLE RegProjectResult MODIFY(ResultKind NOT NULL)
/

-- #########################################################
-- #########################################################
-- alter_BudStruct_add_RegProjectResult.sql
-- #########################################################
-- #########################################################

/*  "  "    */
ALTER TABLE TB_BudStruct ADD (
  RegProjectResult NUMBER(10)/*    */,
    CHECK((RegProjectResult<=2147483647)AND(RegProjectResult>-2147483648))
)
/

CREATE OR REPLACE VIEW BudStruct (
  ID,
  KFSR,
  KVSR,
  KCSR,
  KVR,
  KESR,
  SUBKESR,
  REGIONCLS,
  FACT,
  FINTYPE,
  MEANSTYPE,
  ACTUALDATE,
  CREATEDATE,
  CREATERUSER,
  UPDATEDATE,
  UPDATERUSER,
  DIRECTIONCLS,
  BUDGETREF,
  TRANSFERTCLS,
  STARTDATE,
  ISLIMITSPEND,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  SUBSIDYCLS,
  ASSIGNMENTKIND,
  TARGETCLS,
  CONTRACTCOSTSCLS,
  INVESTOBJECT,
  REGPROJECTRESULT)
AS
  SELECT
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT,
    REGPROJECTRESULT
  FROM TB_BudStruct
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_ID
  INSTEAD OF DELETE
  ON BUDSTRUCT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDSTRUCT_BD_0)
-- - - - - - - - - - - - -

--      BudStrLink
  delete from BudStrLink
  where BudStruct = :old.Id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDSTRUCT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDSTRUCT_AD_500)
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate)
    values(141, :old.ID, SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_II
  INSTEAD OF INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$REGPROJECTRESULT BUDSTRUCT.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCT_BI_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (tr_budstruct_bi_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null)))
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCT_BI_500)
-- Last update 22.02.2004
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDSTRUCT (
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT,
    REGPROJECTRESULT
  ) VALUES (
    new$ID,
    new$KFSR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$REGIONCLS,
    new$FACT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$ACTUALDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$DIRECTIONCLS,
    new$BUDGETREF,
    new$TRANSFERTCLS,
    new$STARTDATE,
    new$ISLIMITSPEND,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$SUBSIDYCLS,
    new$ASSIGNMENTKIND,
    new$TARGETCLS,
    new$CONTRACTCOSTSCLS,
    new$INVESTOBJECT,
    new$REGPROJECTRESULT);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_IU
  INSTEAD OF UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$REGPROJECTRESULT BUDSTRUCT.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCT_BU_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (tr_budstruct_bu_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null))) and
  (id <> :old.id)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDSTRUCT SET
    ID = new$ID,
    KFSR = new$KFSR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    REGIONCLS = new$REGIONCLS,
    FACT = new$FACT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    ACTUALDATE = new$ACTUALDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    DIRECTIONCLS = new$DIRECTIONCLS,
    BUDGETREF = new$BUDGETREF,
    TRANSFERTCLS = new$TRANSFERTCLS,
    STARTDATE = new$STARTDATE,
    ISLIMITSPEND = new$ISLIMITSPEND,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TARGETCLS = new$TARGETCLS,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    INVESTOBJECT = new$INVESTOBJECT,
    REGPROJECTRESULT = new$REGPROJECTRESULT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDSTRUCT_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (141, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=141) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
ALTER TABLE TB_BUDSTRUCT ADD (
  CONSTRAINT FK_BUDSTRUCT_REGPRJRES FOREIGN KEY (RegProjectResult) REFERENCES RegProjectResult(ID)
)
/
CREATE INDEX FK_BUDSTRUCT_REGPRJRES ON TB_BUDSTRUCT(RegProjectResult)
/
commit work 
/
-- ALTER TRIGGER tr_budstruct_bi_100
CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_II
  INSTEAD OF INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$REGPROJECTRESULT BUDSTRUCT.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCT_BI_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (tr_budstruct_bi_100)
-- Version 14.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null))) and
  ((RegProjectResult = new$RegProjectResult) or ((RegProjectResult is null) and (new$RegProjectResult is null)))
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCT_BI_500)
-- Last update 22.02.2004
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDSTRUCT (
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS,
    CONTRACTCOSTSCLS,
    INVESTOBJECT,
    REGPROJECTRESULT
  ) VALUES (
    new$ID,
    new$KFSR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$REGIONCLS,
    new$FACT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$ACTUALDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$DIRECTIONCLS,
    new$BUDGETREF,
    new$TRANSFERTCLS,
    new$STARTDATE,
    new$ISLIMITSPEND,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$SUBSIDYCLS,
    new$ASSIGNMENTKIND,
    new$TARGETCLS,
    new$CONTRACTCOSTSCLS,
    new$INVESTOBJECT,
    new$REGPROJECTRESULT);

END;
/
-- ALTER TRIGGER tr_budstruct_bu_100
CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_IU
  INSTEAD OF UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$CONTRACTCOSTSCLS BUDSTRUCT.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$INVESTOBJECT BUDSTRUCT.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$REGPROJECTRESULT BUDSTRUCT.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
--
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCT_BU_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (tr_budstruct_bu_100)
-- Version 14.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  ((TARGETCLS = new$TARGETCLS) or ((TARGETCLS is null) and (new$TARGETCLS is null))) and
  ((ContractCostsCls = new$ContractCostsCls) or ((ContractCostsCls is null) and (new$ContractCostsCls is null))) and
  ((InvestObject = new$InvestObject) or ((InvestObject is null) and (new$InvestObject is null))) and
  ((RegProjectResult = new$RegProjectResult) or ((RegProjectResult is null) and (new$RegProjectResult is null))) and
  (id <> :old.id)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDSTRUCT SET
    ID = new$ID,
    KFSR = new$KFSR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    REGIONCLS = new$REGIONCLS,
    FACT = new$FACT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    ACTUALDATE = new$ACTUALDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    DIRECTIONCLS = new$DIRECTIONCLS,
    BUDGETREF = new$BUDGETREF,
    TRANSFERTCLS = new$TRANSFERTCLS,
    STARTDATE = new$STARTDATE,
    ISLIMITSPEND = new$ISLIMITSPEND,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TARGETCLS = new$TARGETCLS,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    INVESTOBJECT = new$INVESTOBJECT,
    REGPROJECTRESULT = new$REGPROJECTRESULT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDSTRUCT_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (141, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=141) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_ED_OUT_FACIALACC_field_expansion_FACODE.sql
-- #########################################################
-- #########################################################

ALTER TABLE ED_OUT_FACIALACC MODIFY (FACode VARCHAR2(30))
/
ALTER TABLE ED_OUT_FACIALACC MODIFY (FACODE_OLD VARCHAR2(30))
/
commit work 
/

-- #########################################################
-- #########################################################
-- ALTER_TR_FacialFinDetail_bi_110.sql
-- #########################################################
-- #########################################################

/*   TR_FACIALFINDETAIL_BI_110*/
-- CREATE TRIGGER tr_facialfindetail_bi_110
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
  new$REJECT_CLS FACIALFINDETAIL.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$REJECTCAUSE FACIALFINDETAIL.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$CARDNUMBER FACIALFINDETAIL.CARDNUMBER%TYPE := :NEW.CARDNUMBER;
  new$DATEBIRTH FACIALFINDETAIL.DATEBIRTH%TYPE := :NEW.DATEBIRTH;
  new$PAYMENTCODETYPE FACIALFINDETAIL.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$CODEPURPOSE FACIALFINDETAIL.CODEPURPOSE%TYPE := :NEW.CODEPURPOSE;
  new$LINENUMBER FACIALFINDETAIL.LINENUMBER%TYPE := :NEW.LINENUMBER;
  new$AMOUNTISPDOC FACIALFINDETAIL.AMOUNTISPDOC%TYPE := :NEW.AMOUNTISPDOC;
  new$SOURCEREGPROJECTRESULT FACIALFINDETAIL.SOURCEREGPROJECTRESULT%TYPE := :NEW.SOURCEREGPROJECTRESULT;
  new$DESTREGPROJECTRESULT FACIALFINDETAIL.DESTREGPROJECTRESULT%TYPE := :NEW.DESTREGPROJECTRESULT;
  new$SOURCEINCOMETARGETFUNDS FACIALFINDETAIL.SOURCEINCOMETARGETFUNDS%TYPE := :NEW.SOURCEINCOMETARGETFUNDS;
  new$DESTINCOMETARGETFUNDS FACIALFINDETAIL.DESTINCOMETARGETFUNDS%TYPE := :NEW.DESTINCOMETARGETFUNDS;
  new$SOURCEPAYTARGETFUNDS FACIALFINDETAIL.SOURCEPAYTARGETFUNDS%TYPE := :NEW.SOURCEPAYTARGETFUNDS;
  new$DESTPAYTARGETFUNDS FACIALFINDETAIL.DESTPAYTARGETFUNDS%TYPE := :NEW.DESTPAYTARGETFUNDS;
  new$SOURCEANALYTICALPARTITION FACIALFINDETAIL.SOURCEANALYTICALPARTITION%TYPE := :NEW.SOURCEANALYTICALPARTITION;
  new$DESTANALYTICALPARTITION FACIALFINDETAIL.DESTANALYTICALPARTITION%TYPE := :NEW.DESTANALYTICALPARTITION;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  SourceFacialAcc_CLS1$ NUMBER(10);
  DestFacialAcc_CLS1$ NUMBER(10);
  CapBuhOperationCLS1$ NUMBER(10);
  CapClsType1$ NUMBER(10);
  CapAcceptDate1$ NUMBER(10);
  CapReject_cls$ NUMBER(10);
  CapRejectCause$ VARCHAR2(1000);
  i_fintype1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  BEGIN
    /*  ,    */
    select
    ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate, ffc.Reject_cls, ffc.RejectCause,
    ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
    into new$BudgetRef, CapBuhOperationCLS1$, CapClsType1$, CapAcceptDate1$, CapReject_cls$, CapRejectCause$,
    new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause  from
    FacialFinCaption ffc
    where
    ffc.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*      */
  if (new$BuhOperationCls is null) then
    new$BuhOperationCls := CapBuhOperationCLS1$;
  END IF;
  /*      */
  if (new$ClsType is null) then
    new$ClsType := CapClsType1$;
  END IF;
  if (new$DestClsType is null) then
    new$DestClsType := new$ClsType;
  END IF;
  /*      */
  if (new$AcceptDate is null) then
    new$AcceptDate := CapAcceptDate1$;
  END IF;

  /*       */
  if (new$Reject_cls is null) then
    new$Reject_cls := CapReject_cls$;
  END IF;

  /*       */
  if (new$RejectCause is null) then
    new$RejectCause := CapRejectCause$;
  END IF;
  /*      */
  if ((new$SourceFacialAcc_CLS is null)or
  (new$DestFacialAcc_CLS is null)) then
    BEGIN
      select
      SourceFacialAcc_CLS,
      DestFacialAcc_CLS
      into
      SourceFacialAcc_CLS1$,
      DestFacialAcc_CLS1$    from
      FacialFinCaption
      where
      (new$RecordIndex=id)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$SourceFacialAcc_CLS is null) then
      new$SourceFacialAcc_CLS := SourceFacialAcc_CLS1$ ;
    END IF;
    if (new$DestFacialAcc_CLS is null) then
      new$DestFacialAcc_CLS := DestFacialAcc_CLS1$ ;

    END IF;
  END IF;
  /*         */
  if ((new$AcceptDate is not null) and (new$Reject_CLS is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 14.30.00.1
-- - - - - - - - - - - - -

  /*     ,      */ 
  i_fintype1$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN 
    BEGIN
      SELECT constvalue INTO i_fintype1$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype1$  ;
     
  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN 
    IF (i_fintype1$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype1$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype1$  ;
     
  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN 
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN 
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN 
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN 
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN 
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN 
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN 
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN 
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN 
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN 
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN 
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN 
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN 
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN 
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN 
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN 
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN 
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN 
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN 
    new$DestKVR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN 
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN 
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN 
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN 
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN 
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN 
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN 
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN 
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN 
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN 
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN 
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN 
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN 
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN 
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN 
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  IF (new$progindex=76) THEN
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;
     
  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN 
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;
         
    ELSE 
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;
           
      ELSE 
        IF ((new$progindex IN (66, 67, 76)) AND (new$DestPromise IS NOT NULL) AND
        (new$SourcePromise = new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF; 
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;
           
      ELSE 
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;
             
        ELSE 
          IF (new$progindex IN (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;
               
          END IF;
        END IF; 
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
   
  /*       */
  IF (((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) OR (new$STIMATEID IS NOT NULL))  THEN
    IF (new$ProgIndex <> 76) THEN /*  03.24   .    */
      GETTARGETCLS(NULL, new$sourcetransfertcls, NULL, new$sourcemeanstype,
      new$sourcetargetcls,new$sourcetargetcls);
    END IF;
    GETTARGETCLS(NULL, new$desttransfertcls, NULL, new$destmeanstype,
    new$desttargetcls,new$desttargetcls);
    IF (new$ProgIndex = 76) THEN
      new$SourceTargetCls := new$DestTargetCls;
     
    END IF;
  END IF;
  /*      */
  GetDocumentKESR(NULL, new$SourceSubKESR, new$SourceKESR, new$BudgetRef,new$SourceKESR);
  GetDocumentKESR(NULL, new$DestSubKESR, new$DestKESR, new$BudgetRef,new$DestKESR);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 14.20.00.1
-- - - - - - - - - - - - -

  /*       60 :  '   .'; source
            61 :  '      '; dest
            62 :  '   ';dest
            63 :  '    '; source
            64 :  '   '; source
            65 :  ' , ';dest
            66 :  '  ,  - '; source dest
            67 :  '   ';source
            68 :  '  \ ';dest
            69 :  '   \ '; dest
            70 :  '  \ ';source
            71 :  '   \ '; dest
          283 :  '   '; source */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70,283))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70,283))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70,283)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70,283)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70,283)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum)
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;

    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS,
    REJECT_CLS,
    REJECTCAUSE,
    CARDNUMBER,
    DATEBIRTH,
    PAYMENTCODETYPE,
    CODEPURPOSE,
    LINENUMBER,
    AMOUNTISPDOC,
    SOURCEREGPROJECTRESULT,
    DESTREGPROJECTRESULT,
    SOURCEINCOMETARGETFUNDS,
    DESTINCOMETARGETFUNDS,
    SOURCEPAYTARGETFUNDS,
    DESTPAYTARGETFUNDS,
    SOURCEANALYTICALPARTITION,
    DESTANALYTICALPARTITION,
    NOTE
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS,
    new$REJECT_CLS,
    new$REJECTCAUSE,
    new$CARDNUMBER,
    new$DATEBIRTH,
    new$PAYMENTCODETYPE,
    new$CODEPURPOSE,
    new$LINENUMBER,
    new$AMOUNTISPDOC,
    new$SOURCEREGPROJECTRESULT,
    new$DESTREGPROJECTRESULT,
    new$SOURCEINCOMETARGETFUNDS,
    new$DESTINCOMETARGETFUNDS,
    new$SOURCEPAYTARGETFUNDS,
    new$DESTPAYTARGETFUNDS,
    new$SOURCEANALYTICALPARTITION,
    new$DESTANALYTICALPARTITION,
    new$NOTE);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- UpdDocFields_14.30.00_Ora.sql
-- #########################################################
-- #########################################################


--  : 143000 - 143000.     22.02.2022 14:48:57.
CREATE OR REPLACE PROCEDURE ImportDocType (
   ID_               NUMBER,
   PROGINDEX_        NUMBER,
   NAME_             VARCHAR2,
   USESTATE_         NUMBER,
   DBTABLE_          VARCHAR2,
   NEEDEDS_          NUMBER,
   LOCKMASK_         NUMBER,
   DEFAULTACTIONMACROSNAME_ VARCHAR2,
   DOCUMENTKIND_     NUMBER,
   SHORTNAME_         VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentTypes
    WHERE (ID = ID_);

  IF (IDExists$ = 0) THEN
     INSERT INTO DocumentTypes
                 (ID, PROGINDEX, NAME, USESTATE, DBTABLE, NEEDEDS, LOCKMASK, DEFAULTACTIONMACROSNAME, DOCUMENTKIND, SHORTNAME)
          VALUES (ID_, PROGINDEX_, NAME_, USESTATE_, DBTABLE_, NEEDEDS_, LOCKMASK_, DEFAULTACTIONMACROSNAME_, DOCUMENTKIND_, SHORTNAME_);
  else
      Update documenttypes set
        Name=Name_,
		    DBTABLE=DBTABLE_,
        LockMask=LockMask_,
        DEFAULTACTIONMACROSNAME=DEFAULTACTIONMACROSNAME_,
        DOCUMENTKIND=DOCUMENTKIND_,
        SHORTNAME=SHORTNAME_,
	      PROGINDEX=PROGINDEX_
      where (id=ID_)
        and (
          (Name<>Name_) or
          (length(Name)<>length(Name_)) or 
          ((LockMask is null) and (LockMask_ is not null)) or
          ((LockMask is not null) and (LockMask_ is null)) or
          ((LockMask is not null) and (LockMask_ is not null) and (LockMask <> LockMask_)) or
          (DEFAULTACTIONMACROSNAME is null) or
          (DOCUMENTKIND<>DOCUMENTKIND_) or 
          (SHORTNAME is null) or 
          (SHORTNAME<>SHORTNAME_) or
          (PROGINDEX <> PROGINDEX_) or 
          ((DBTABLE is null) and (DBTABLE_ is not null)) or
          ((DBTABLE is not null) and (DBTABLE_ is null)) or
          ((DBTABLE is not null) and (DBTABLE_ is not null) and (DBTABLE <> DBTABLE_))
        );
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE UPDATEINTERFACES (
  CLS_   NUMBER,
  NOTE_  VARCHAR2,
  GUID_  VARCHAR2,
  PARAM_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT (ID)
   INTO IDEXISTS$
   FROM INTERFACES
  WHERE (GUID=GUID_);
  
  IF (IDExists$ = 0)  THEN
    INSERT INTO INTERFACES
      (CLS,NOTE,GUID,PARAM)
    VALUES
      (CLS_,NOTE_,GUID_,PARAM_);
  ELSE
    IF ((PARAM_ ='')OR(PARAM_ IS NULL)) THEN 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    ELSE 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND (PARAM=PARAM_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    END IF;
  END IF;
END;
/

--   
CALL ImportDocType(9935, 0, ' ', 0, 'CoFinancingLevel', 0,0,'',20100,'') ;

CALL UpdateInterfaces(9935, ' ', '{66560609-DD1F-478B-859E-B26B029B16D2}', '') ;

CALL ImportDocType(9936, 0, '    ', 0, 'RemoteMailMessages', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9936, '    ', '{5BA0A88A-9B78-44C8-AB3B-765F20230FFF}', '') ;

DROP PROCEDURE ImportDocType
/

DROP PROCEDURE UPDATEINTERFACES
/



CREATE OR REPLACE PROCEDURE SELECTIONS_IMPORT(
  ID_ NUMBER,
  KIND_ NUMBER,
  NAME_ VARCHAR2,
  NOTE_ VARCHAR2,
  READONLY_ NUMBER,
  USEINDOC_ NUMBER,
  TABLENAME_ VARCHAR2,
  ALIAS_ VARCHAR2,
  TABLECODE_ NUMBER,
  NEEDGROUPONDB_ NUMBER,
  NEEDDISTINCT_ NUMBER,
  MASTER_ NUMBER,
  DISCRIMVALUE_ VARCHAR2,
  AVAILABLEINDEREF_ NUMBER,
  CACHETYPE_ NUMBER,
  FULLORMODINSREFRTIME_ NUMBER,
  DELETEREFRTIME_ NUMBER,
  FINDTIMEREFRESH_ NUMBER,
  ANNOTATION_ VARCHAR2,
  DEREFNAME_ VARCHAR2,
  GroupID_ NUMBER,
  IsLogged_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONS SET
      KIND = KIND_,
      NAME = NAME_,
      NOTE = NOTE_,
      READONLY = READONLY_,
      USEINDOC = USEINDOC_,
      TABLENAME = TABLENAME_,
      ALIAS = ALIAS_,
      TABLECODE = TABLECODE_,    
      NEEDGROUPONDB = NEEDGROUPONDB_,
      NEEDDISTINCT = NEEDDISTINCT_,
      MASTER = MASTER_,
      DISCRIMVALUE = DISCRIMVALUE_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,         
      CACHETYPE = CACHETYPE_,   
      FULLORMODINSREFRTIME = FULLORMODINSREFRTIME_,   
      DELETEREFRTIME = DELETEREFRTIME_,   
      FINDTIMEREFRESH = FINDTIMEREFRESH_,   
      ANNOTATION = ANNOTATION_,   
      DEREFNAME = DEREFNAME_,     
      GroupID = GroupID_, 
      IsLogged = IsLogged_  
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONS
      (ID, KIND, NAME, NOTE, READONLY, USEINDOC, TABLENAME, ALIAS, TABLECODE, NEEDGROUPONDB, NEEDDISTINCT, MASTER, DISCRIMVALUE,
      AVAILABLEINDEREF, CACHETYPE, FULLORMODINSREFRTIME, DELETEREFRTIME, FINDTIMEREFRESH, ANNOTATION, DEREFNAME, GroupID, IsLogged)
    VALUES
      (ID_, KIND_, NAME_, NOTE_, READONLY_, USEINDOC_, TABLENAME_, ALIAS_, TABLECODE_, NEEDGROUPONDB_, NEEDDISTINCT_, MASTER_, DISCRIMVALUE_,
      AVAILABLEINDEREF_, CACHETYPE_, FULLORMODINSREFRTIME_, DELETEREFRTIME_, FINDTIMEREFRESH_, ANNOTATION_, DEREFNAME_, GroupID_, IsLogged_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  ALIAS_ VARCHAR2,
  JOINORDER_ NUMBER,
  JOINTYPE_ NUMBER,
  RELATIONTYPE_ NUMBER,
  JOINCONDITION_ VARCHAR2,
  DONTUSETABLELIMITS_ NUMBER,
  LIMITNAMESLIST_ VARCHAR2,
  QueryGroup_ NUMBER  
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONSDETAIL
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONSDETAIL SET
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      ALIAS = ALIAS_,
      JOINORDER = JOINORDER_,
      JOINTYPE = JOINTYPE_,
      RELATIONTYPE = RELATIONTYPE_,
      JOINCONDITION = JOINCONDITION_,
      DONTUSETABLELIMITS = DONTUSETABLELIMITS_,
      LIMITNAMESLIST = LIMITNAMESLIST_,
      QueryGroup = QueryGroup_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONSDETAIL
      (ID, SELECTIONREF, TABLEREF, ALIAS, JOINORDER, JOINTYPE, RELATIONTYPE, JOINCONDITION, DONTUSETABLELIMITS, LIMITNAMESLIST, QueryGroup)
    VALUES
      (ID_, SELECTIONREF_, TABLEREF_, ALIAS_, JOINORDER_, JOINTYPE_, RELATIONTYPE_, JOINCONDITION_, DONTUSETABLELIMITS_, LIMITNAMESLIST_, QueryGroup_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_IMPORT(
  ID_ NUMBER,
  FIELDKIND_ NUMBER,
  DESCRIPTIONLEVEL_ NUMBER,
  ANCESTORREF_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  FIELDNAME_ VARCHAR2,
  DATATYPE_ NUMBER,
  SUBDATATYPE_ NUMBER,
  FIELDSIZE_ NUMBER,
  DISPLAYLABEL_ VARCHAR2,
  NOTE_ VARCHAR2,
  DEFAULTWIDTH_ NUMBER,
  EDITMASK_ VARCHAR2,
  DISPLAYFORMAT_ VARCHAR2,
  EDITFORMAT_ VARCHAR2,
  CANTEDIT_ NUMBER,
  NOVISUALIZE_ NUMBER,
  ENUMSREF_ NUMBER,
  REQUIRED_ NUMBER,
  FOREIGNKEY_ NUMBER,
  ONDELACTION_ NUMBER,
  PRIMARYKEY_ NUMBER,
  ISRVERSION_ NUMBER,
  LIMITPARAMNAMES_ VARCHAR2,
  FOLLOWORDER_ NUMBER,
  SORTDIRECTION_ NUMBER,
  SORTORDER_ NUMBER,
  AGRFUNCTION_ NUMBER,
  FLAGFIELDNAME_ NUMBER,
  FLAGDISPLAYLABEL_ NUMBER,
  FLAGNOTE_ NUMBER,
  FLAGDEFAULTWIDTH_ NUMBER,
  FLAGCANTEDIT_ NUMBER,
  FLAGNOVISUALIZE_ NUMBER,
  FLAGREQUIRED_ NUMBER,
  FLAGLIMITPARAMNAMES_ NUMBER,
  FLAGAGRFUNCTION_ NUMBER,
  ISTIMESTAMPFIELD_ NUMBER,
  ISBUDGET_ NUMBER,
  AVAILABLEINDEREF_ NUMBER,
  ANNOTATION_ VARCHAR2,
  ALIAS_ VARCHAR2,
  DEREFNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM FIELDSINFO
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE FIELDSINFO SET
      FIELDKIND = FIELDKIND_,
      DESCRIPTIONLEVEL = DESCRIPTIONLEVEL_,
      ANCESTORREF = ANCESTORREF_,
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      FIELDNAME = FIELDNAME_,
      DATATYPE = DATATYPE_,
      SUBDATATYPE = SUBDATATYPE_,
      FIELDSIZE = FIELDSIZE_,
      DISPLAYLABEL = DISPLAYLABEL_,
      NOTE = NOTE_,
      DEFAULTWIDTH = DEFAULTWIDTH_,
      EDITMASK = EDITMASK_,
      DISPLAYFORMAT = DISPLAYFORMAT_,
      EDITFORMAT = EDITFORMAT_,
      CANTEDIT = CANTEDIT_,
      NOVISUALIZE = NOVISUALIZE_,
      ENUMSREF = ENUMSREF_,
      REQUIRED = REQUIRED_,
      FOREIGNKEY = FOREIGNKEY_,
      ONDELACTION = ONDELACTION_,
      PRIMARYKEY = PRIMARYKEY_,
      ISRVERSION = ISRVERSION_,
      LIMITPARAMNAMES = LIMITPARAMNAMES_,
      FOLLOWORDER = FOLLOWORDER_,
      SORTDIRECTION = SORTDIRECTION_,
      SORTORDER = SORTORDER_,
      AGRFUNCTION = AGRFUNCTION_,
      FLAGFIELDNAME = FLAGFIELDNAME_,
      FLAGDISPLAYLABEL = FLAGDISPLAYLABEL_,
      FLAGNOTE = FLAGNOTE_,
      FLAGDEFAULTWIDTH = FLAGDEFAULTWIDTH_,
      FLAGCANTEDIT = FLAGCANTEDIT_,
      FLAGNOVISUALIZE = FLAGNOVISUALIZE_,
      FLAGREQUIRED = FLAGREQUIRED_,
      FLAGLIMITPARAMNAMES = FLAGLIMITPARAMNAMES_,
      FLAGAGRFUNCTION = FLAGAGRFUNCTION_,
      ISTIMESTAMPFIELD = ISTIMESTAMPFIELD_,
      ISBUDGET = ISBUDGET_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,
      ANNOTATION = ANNOTATION_,
      ALIAS = ALIAS_,
      DEREFNAME = DEREFNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO FIELDSINFO
      (ID, FIELDKIND, DESCRIPTIONLEVEL, ANCESTORREF, SELECTIONREF, TABLEREF, FIELDNAME, DATATYPE, SUBDATATYPE,
       FIELDSIZE, DISPLAYLABEL, NOTE, DEFAULTWIDTH, EDITMASK, DISPLAYFORMAT, EDITFORMAT, CANTEDIT, NOVISUALIZE,
       ENUMSREF, REQUIRED, FOREIGNKEY, ONDELACTION, PRIMARYKEY, ISRVERSION, LIMITPARAMNAMES,
       FOLLOWORDER, SORTDIRECTION, SORTORDER, AGRFUNCTION, FLAGFIELDNAME, FLAGDISPLAYLABEL, FLAGNOTE,
       FLAGDEFAULTWIDTH, FLAGCANTEDIT, FLAGNOVISUALIZE, FLAGREQUIRED, FLAGLIMITPARAMNAMES, FLAGAGRFUNCTION,
       ISTIMESTAMPFIELD, ISBUDGET, AVAILABLEINDEREF, ANNOTATION, ALIAS, DEREFNAME)
    VALUES
      (ID_, FIELDKIND_, DESCRIPTIONLEVEL_, ANCESTORREF_, SELECTIONREF_, TABLEREF_, FIELDNAME_, DATATYPE_, SUBDATATYPE_,
       FIELDSIZE_, DISPLAYLABEL_, NOTE_, DEFAULTWIDTH_, EDITMASK_, DISPLAYFORMAT_, EDITFORMAT_, CANTEDIT_, NOVISUALIZE_,
       ENUMSREF_, REQUIRED_, FOREIGNKEY_, ONDELACTION_, PRIMARYKEY_, ISRVERSION_, LIMITPARAMNAMES_,
       FOLLOWORDER_, SORTDIRECTION_, SORTORDER_, AGRFUNCTION_, FLAGFIELDNAME_, FLAGDISPLAYLABEL_, FLAGNOTE_,
       FLAGDEFAULTWIDTH_, FLAGCANTEDIT_, FLAGNOVISUALIZE_, FLAGREQUIRED_, FLAGLIMITPARAMNAMES_, FLAGAGRFUNCTION_,
       ISTIMESTAMPFIELD_, ISBUDGET_, AVAILABLEINDEREF_, ANNOTATION_, ALIAS_, DEREFNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  EVENTCODE_ NUMBER,
  SCRIPTNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONEVENTS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONEVENTS SET
      SELECTIONREF = SELECTIONREF_,
      EVENTCODE = EVENTCODE_,
      SCRIPTNAME = SCRIPTNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONEVENTS
      (ID, SELECTIONREF, EVENTCODE, SCRIPTNAME)
    VALUES
      (ID_, SELECTIONREF_, EVENTCODE_, SCRIPTNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_DELETE(
  ID_ NUMBER
) IS
BEGIN
  UPDATE DOCUMENTFIELDS SET
    FIELDINFOREF = NULL
  WHERE FIELDINFOREF = ID_;
  DELETE FROM FIELDSINFO FI
  WHERE FI.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONSDETAIL SLD
  WHERE SLD.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONEVENTS SE
  WHERE SE.ID = ID_;
END;
/

-- 
CALL SELECTIONS_IMPORT(48008, 1, 'COFINANCINGLEVEL', ' ', 0, 0, 'COFINANCINGLEVEL', 'CoFinancingLevel', 0, 0, 0, 2, '', 1, 1, 3600, null, null, '', '', null, 0) ;

-- COFINANCINGLEVEL
CALL FIELDSINFO_IMPORT(48009, 0, 1, null, 48008, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48010, 0, 1, null, 48008, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 11, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48011, 0, 1, null, 48008, null, 'BUDGETLEVEL', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48012, 0, 1, null, 48008, null, 'PERCENT', 1, 0, 20, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48013, 0, 1, null, 48008, null, 'MEANSTYPE', 3, 0, 0, ' ', '  ', 11, '99.99.99', '', '', 0, 0, null, 1, 17311, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48014, 0, 1, null, 48008, null, 'KCSR', 3, 0, 0, ' ()', '  ', 11, '999.99.99', '', '', 0, 0, null, 1, 16857, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48015, 0, 1, null, 48008, null, 'COMMDIRECTIONEXPENCECLS', 3, 0, 0, '  ()', '      ', 11, '', '', '', 0, 0, null, 1, 32786, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48016, 0, 1, null, 48008, null, 'TRANSFERTCLS', 3, 0, 0, '   ()', '    ', 11, '', '', '', 0, 0, null, 0, 22773, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48017, 0, 1, null, 48008, null, 'BUDGETREF', 3, 0, 0, ' ', '  ,    ', 11, '999', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48018, 0, 1, null, 48008, null, 'OKTMO', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, 32820, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48019, 0, 1, null, 48008, null, 'PARENTCOFINANCINGLEVEL', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 0, 48008, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48020, 0, 1, null, 48008, null, 'NOTE', 1, 0, 255, '', '', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48021, 0, 1, null, 48008, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48022, 0, 1, null, 48008, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48023, 0, 1, null, 48008, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48024, 0, 1, null, 48008, null, 'CREATERUSER', 1, 0, 30, ' ()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48025, 0, 1, null, 48008, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(48026, 0, 1, null, 48008, null, 'UPDATERUSER', 1, 0, 30, ' ()', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

--  
DROP PROCEDURE SELECTIONS_IMPORT
/

DROP PROCEDURE SELECTIONSDETAIL_IMPORT
/

DROP PROCEDURE FIELDSINFO_IMPORT
/

DROP PROCEDURE SELECTIONEVENTS_IMPORT
/

DROP PROCEDURE FIELDSINFO_DELETE
/

DROP PROCEDURE SELECTIONSDETAIL_DELETE
/

DROP PROCEDURE SELECTIONS_DELETE
/

DROP PROCEDURE SELECTIONEVENTS_DELETE
/

CREATE OR REPLACE PROCEDURE ImportDocCLS (
   ID_                 NUMBER,
   DOCTYPE_            NUMBER,
   DOCTYPENOTE_        VARCHAR2,
   TABLENAME_          VARCHAR2,
   TABLENAMEURM_       VARCHAR2,
   PRIMARYKEYNAME_     VARCHAR2,
   PRIMARYKEYNAMEURM_  VARCHAR2,
   LINKFIELDNAME_      VARCHAR2,
   LINKFIELDNAMEURM_   VARCHAR2,
   CLSTYPE_            NUMBER,
   SELECTIONREFBUDGET_ NUMBER,
   SELECTIONREFURM_    NUMBER,
   PROGINDEX_          NUMBER
) IS IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
   INTO IDExists$
   FROM DOCUMENTCLS
   WHERE (ID = ID_);

   IF (IDExists$ = 0) THEN
   INSERT INTO DOCUMENTCLS
   (ID, DOCTYPE, DOCTYPENOTE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM, LINKFIELDNAME, LINKFIELDNAMEURM, CLSTYPE, 
     SELECTIONREFBUDGET, SELECTIONREFURM, PROGINDEX)
   VALUES (ID_, DOCTYPE_, DOCTYPENOTE_, TABLENAME_, TABLENAMEURM_, PRIMARYKEYNAME_, PRIMARYKEYNAMEURM_, LINKFIELDNAME_, LINKFIELDNAMEURM_, CLSTYPE_, 
     SELECTIONREFBUDGET_, SELECTIONREFURM_, PROGINDEX_);
   ELSE
   UPDATE DOCUMENTCLS 
   SET
     DOCTYPENOTE = DOCTYPENOTE_,
     TABLENAME = TABLENAME_,
     TABLENAMEURM = TABLENAMEURM_,
     PRIMARYKEYNAME = PRIMARYKEYNAME_,
     PRIMARYKEYNAMEURM = PRIMARYKEYNAMEURM_,
     LINKFIELDNAME = LINKFIELDNAME_,
     LINKFIELDNAMEURM = LINKFIELDNAMEURM_,
     CLSTYPE = CLSTYPE_,
     SELECTIONREFBUDGET = SELECTIONREFBUDGET_,
     SELECTIONREFURM = SELECTIONREFURM_,
     PROGINDEX = PROGINDEX_
   WHERE  
    (ID = ID_)
    AND NOT (
            (
                    ((DOCTYPENOTE IS NOT NULL AND DOCTYPENOTE_ IS NOT NULL) AND
                       (UPPER (DOCTYPENOTE) = UPPER (DOCTYPENOTE_))
                    )
                    OR (DOCTYPENOTE IS NULL AND DOCTYPENOTE_ IS NULL)
                )    
        AND (UPPER (TABLENAME) = UPPER (TABLENAME_))    
        AND (
                    ((TABLENAMEURM IS NOT NULL AND TABLENAMEURM_ IS NOT NULL) AND
                       (UPPER (TABLENAMEURM) = UPPER (TABLENAMEURM_))
                    )
                    OR (TABLENAMEURM IS NULL AND TABLENAMEURM_ IS NULL)
                )    
        AND (UPPER (PRIMARYKEYNAME) = UPPER (PRIMARYKEYNAME_))
        AND (
                    ((PRIMARYKEYNAMEURM IS NOT NULL AND PRIMARYKEYNAMEURM_ IS NOT NULL) AND
                       (UPPER (PRIMARYKEYNAMEURM) = UPPER (PRIMARYKEYNAMEURM_))
                    )
                    OR (PRIMARYKEYNAMEURM IS NULL AND PRIMARYKEYNAMEURM_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAME IS NOT NULL AND LINKFIELDNAME_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAME) = UPPER (LINKFIELDNAME_))
                    )
                    OR (LINKFIELDNAME IS NULL AND LINKFIELDNAME_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAMEURM IS NOT NULL AND LINKFIELDNAMEURM_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAMEURM) = UPPER (LINKFIELDNAMEURM_))
                    )
                    OR (LINKFIELDNAMEURM IS NULL AND LINKFIELDNAMEURM_ IS NULL)
                )    
        AND (
                    ((CLSTYPE IS NOT NULL AND CLSTYPE_ IS NOT NULL) AND
                       (UPPER (CLSTYPE) = UPPER (CLSTYPE_))
                    )
                    OR (CLSTYPE IS NULL AND CLSTYPE_ IS NULL)
                ) 
        AND (
                    ((PROGINDEX IS NOT NULL AND PROGINDEX_ IS NOT NULL) AND
                       (PROGINDEX = PROGINDEX_)
                    )
                    OR (PROGINDEX IS NULL AND PROGINDEX_ IS NULL)
                )   
            );
   
   END IF;
END;
/

--   
CALL ImportDocCLS(10100, 101, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10101, 101, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10102, 101, ' ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10103, 101, ' ', 'DEBT', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10104, 101, ' %  ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10105, 101, ' ', 'INCOMES32', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20100, 201, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(20101, 201, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(30100, 301, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30101, 301, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30200, 302, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30201, 302, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30300, 303, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30301, 303, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30400, 304, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30401, 304, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30500, 305, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30501, 305, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30600, 306, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30601, 306, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30700, 307, '', 'FACIALFINREESTR', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(31100, 311, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31101, 311, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31200, 312, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31201, 312, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31400, 314, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31401, 314, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31500, 315, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(31501, 315, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(992500, 9925, '', 'Cards', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992501, 9925, ' ', 'CARDSDETAIL_FACC', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(490300, 4903, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 527) ;

CALL ImportDocCLS(32200, 322, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32201, 322, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32300, 323, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32301, 323, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32400, 324, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(32401, 324, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(40100, 401, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 130) ;

CALL ImportDocCLS(40101, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 131) ;

CALL ImportDocCLS(40102, 401, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 137) ;

CALL ImportDocCLS(40103, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 132) ;

CALL ImportDocCLS(40104, 401, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 134) ;

CALL ImportDocCLS(40105, 401, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 138) ;

CALL ImportDocCLS(40106, 401, ' %', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 133) ;

CALL ImportDocCLS(40107, 401, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40108, 401, '. ', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40109, 401, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 340) ;

CALL ImportDocCLS(40110, 401, '.', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 341) ;

CALL ImportDocCLS(40111, 401, '', 'LOANCREDITCONTRACTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 342) ;

CALL ImportDocCLS(50100, 501, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 120) ;

CALL ImportDocCLS(50101, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 121) ;

CALL ImportDocCLS(50102, 501, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 127) ;

CALL ImportDocCLS(50103, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 122) ;

CALL ImportDocCLS(50104, 501, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 124) ;

CALL ImportDocCLS(50105, 501, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 128) ;

CALL ImportDocCLS(50106, 501, ' %', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 123) ;

CALL ImportDocCLS(50107, 501, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(50108, 501, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 321) ;

CALL ImportDocCLS(70100, 701, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70101, 701, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70200, 702, '', 'PAYDOC32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70201, 702, '', 'PAYDOC32', ' ', 'ID', ' ', 'PARENTINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70300, 703, '', 'FINDOCDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, 36) ;

CALL ImportDocCLS(80100, 801, '', 'LIMITNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80101, 801, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 57) ;

CALL ImportDocCLS(80200, 802, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80300, 803, '', 'REQUESTFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80301, 803, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80400, 804, '', 'LIMITFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90100, 901, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 145) ;

CALL ImportDocCLS(90101, 901, '', 'INCOMES32', ' ', 'ID', ' ', 'RecordIndex', ' ', 0, null, null, 0) ;

CALL ImportDocCLS(90300, 903, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90301, 903, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90500, 905, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 44) ;

CALL ImportDocCLS(90600, 906, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 41) ;

CALL ImportDocCLS(90601, 906, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 42) ;

CALL ImportDocCLS(120100, 1201, '', 'BUH_JOURNAL', ' ', 'ID', ' ', '', ' ', 0, null, null, 309) ;

CALL ImportDocCLS(150100, 1501, '', 'ORGOPERAT', ' ', 'ID', ' ', '', ' ', 0, null, null, 35) ;

CALL ImportDocCLS(160100, 1601, '', 'PROMISE_CAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(160101, 1601, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', 'TITLE_REF', ' ', 0, null, null, 345) ;

CALL ImportDocCLS(160200, 1602, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(170100, 1701, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 222) ;

CALL ImportDocCLS(170200, 1702, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 221) ;

CALL ImportDocCLS(170201, 1702, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(190100, 1901, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(190101, 1901, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(220100, 2201, '', 'BUDNOTIFY', 'BUDNOTIFY', 'ID', ' ', '', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(220101, 2201, '', 'BUDGETDATA', 'BUDGETDATA', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(280100, 2801, '', 'ACCSOPERTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(280101, 2801, '', 'PAYDOC32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 16) ;

CALL ImportDocCLS(280200, 2802, '', 'DFACCOUNTOPERATION', ' ', 'ID', ' ', '', ' ', 0, null, null, 50) ;

CALL ImportDocCLS(440100, 4401, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(440101, 4401, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(0, 0, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991304, 9913, ' ', 'STATICLINKS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(440300, 4403, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(440301, 4403, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(989500, 9895, ' ', 'OKTMO', 'OKTMO', 'id', 'id', '', '', 95, null, null, null) ;

CALL ImportDocCLS(990300, 9903, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990301, 9903, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990302, 9903, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990500, 9905, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90200, 902, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 38) ;

CALL ImportDocCLS(20701, 207, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(90700, 907, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181200, 1812, '', 'ED_CorrectionCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181000, 1810, '', 'ED_OUTPAYDOC', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20700, 207, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(181001, 1810, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992700, 9927, '', 'REMOTECLIENT', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550100, 5501, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(20801, 208, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(30701, 307, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', 'REESTR_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21100, 211, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 275) ;

CALL ImportDocCLS(490100, 4901, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 525) ;

CALL ImportDocCLS(992701, 9927, '  ', 'REMOTEREADRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(550101, 5501, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(490301, 4903, '', 'ARCHIVEOPLOG', ' ', 'ID', ' ', 'DATAPACKETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(390100, 3901, '', 'DELOIN', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21101, 211, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(992300, 9923, '', 'SIGNSCHEMECAPTION', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181201, 1812, '', 'ED_CorrectionDetail', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(550200, 5502, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(20800, 208, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(550201, 5502, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(90000, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992301, 9923, '', 'SIGNSCHEMEDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991600, 9916, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992200, 9922, '', 'ARCHIVEDOCTYPE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(90001, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(390101, 3901, '', 'DELOEXEC', ' ', 'ID', ' ', 'DOCID', ' ', 0, null, null, null) ;

CALL ImportDocCLS(180700, 1807, '', 'PayDocExchange', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21102, 211, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(991700, 9917, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991200, 9912, '', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181600, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30800, 308, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250100, 2501, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 305) ;

CALL ImportDocCLS(21200, 212, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 276) ;

CALL ImportDocCLS(250101, 2501, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(30801, 308, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250200, 2502, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 304) ;

CALL ImportDocCLS(250201, 2502, ' ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(988900, 9889, ' ', 'SubsidyCls', ' ', 'id', ' ', '', '', 89, null, null, null) ;

CALL ImportDocCLS(250202, 2502, '  ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(988700, 9887, ' ', 'VariantCls', ' ', 'ID', ' ', '', '', 87, null, null, null) ;

CALL ImportDocCLS(520100, 5201, '', 'WritExecutionCaption', 'WritExecutionCaption', 'id', 'id', '', '', 0, null, null, 555) ;

CALL ImportDocCLS(990800, 9908, '', 'DocumentTypes', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(250300, 2503, '', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21201, 212, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(250301, 2503, '', 'EXECUTIONDOCUMENTSDETAIL', 'EXECUTIONDOCUMENTSDETAIL', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(180500, 1805, '', 'BANKEXCH_MERDOC', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20201, 202, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20301, 203, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20401, 204, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20501, 205, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20601, 206, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190201, 1902, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190301, 1903, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(20000, 200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190601, 1906, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(20200, 202, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20300, 203, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20400, 204, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20500, 205, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20600, 206, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190200, 1902, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190300, 1903, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(180501, 1805, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(190600, 1906, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(988400, 9884, ' ', 'TransfertCLS', ' ', 'ID', ' ', '', '', 84, null, null, null) ;

CALL ImportDocCLS(988800, 9888, ' ', 'OKP', ' ', 'ID', ' ', '', '', 88, null, null, null) ;

CALL ImportDocCLS(989900, 9899, ' ', 'DBUsers', ' ', 'ID', ' ', '', '', 201, null, null, null) ;

CALL ImportDocCLS(990801, 9908, ' ', 'DOCUMENTFIELDS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(361000, 3610, '', 'UTYPEDFORMSCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 550) ;

CALL ImportDocCLS(987200, 9872, ' ', 'BalanceCls', ' ', 'ID', ' ', '', '', 72, null, null, null) ;

CALL ImportDocCLS(984600, 9846, ' ', 'BUHPAYMENTCLS', ' ', 'ID', ' ', '', '', 46, null, null, null) ;

CALL ImportDocCLS(981800, 9818, ' ', 'CURRENCYCLS', ' ', 'ID', ' ', '', '', 18, null, null, null) ;

CALL ImportDocCLS(988500, 9885, ' ', 'AssignmentKind', ' ', 'ID', ' ', '', '', 85, null, null, null) ;

CALL ImportDocCLS(983500, 9835, ' ', 'BUDGETTYPE', ' ', 'ID', ' ', '', '', 35, null, null, null) ;

CALL ImportDocCLS(985800, 9858, ' ', 'DEBTTYPE', ' ', 'ID', ' ', '', '', 58, null, null, null) ;

CALL ImportDocCLS(988600, 9886, ' ', 'AssignmentSource', ' ', 'ID', ' ', ' ', ' ', 86, null, null, null) ;

CALL ImportDocCLS(988300, 9883, ' ', 'Org_Type', ' ', 'ID', ' ', '', '', 83, null, null, null) ;

CALL ImportDocCLS(986400, 9864, ' ', 'PlanDocType', ' ', 'ID', ' ', '', '', 64, null, null, null) ;

CALL ImportDocCLS(985700, 9857, ' ', 'LOANTYPE', ' ', 'ID', ' ', '', '', 57, null, null, null) ;

CALL ImportDocCLS(984300, 9843, ' ', 'PAYTYPECLS', ' ', 'ID', ' ', '', '', 43, null, null, null) ;

CALL ImportDocCLS(982300, 9823, ' ', 'GOSNI', ' ', 'ID', ' ', '', '', 23, null, null, null) ;

CALL ImportDocCLS(982200, 9822, ' ', 'GroupInf_CLS', ' ', 'ID', ' ', '', '', 22, null, null, null) ;

CALL ImportDocCLS(982900, 9829, ' ', 'DocBase', ' ', 'ID', ' ', '', '', 29, null, null, null) ;

CALL ImportDocCLS(981100, 9811, ' ', 'DocTypes', ' ', 'ID', ' ', '', '', 11, null, null, null) ;

CALL ImportDocCLS(986000, 9860, ' ', 'MEASUREMENTCLS', ' ', 'ID', ' ', '', '', 60, null, null, null) ;

CALL ImportDocCLS(988000, 9880, ' ', 'FundsSource', ' ', 'ID', ' ', '', '', 80, null, null, null) ;

CALL ImportDocCLS(985200, 9852, ' ', 'InnerFinSource', ' ', 'ID', ' ', '', '', 52, null, null, null) ;

CALL ImportDocCLS(981300, 9813, ' ', 'NOTIFYTYPES', ' ', 'ID', ' ', '', '', 13, null, null, null) ;

CALL ImportDocCLS(984500, 9845, ' ', 'PAYSYMBOLCLS', ' ', 'ID', ' ', '', '', 45, null, null, null) ;

CALL ImportDocCLS(980400, 9804, ' ', 'KVR', ' ', 'ID', ' ', '', '', 4, null, null, null) ;

CALL ImportDocCLS(980300, 9803, ' ', 'KVSR', ' ', 'ID', ' ', '', '', 3, null, null, null) ;

CALL ImportDocCLS(980900, 9809, ' ', 'KD', ' ', 'ID', ' ', '', '', 9, null, null, null) ;

CALL ImportDocCLS(984700, 9847, ' ', 'TYPEOPERATIONCLS', ' ', 'ID', ' ', '', '', 47, null, null, null) ;

CALL ImportDocCLS(986800, 9868, ' ', 'KESR', ' ', 'ID', ' ', '', '', 68, null, null, null) ;

CALL ImportDocCLS(987900, 9879, ' ', 'TargetCls', ' ', 'ID', ' ', '', '', 79, null, null, null) ;

CALL ImportDocCLS(985100, 9851, ' ', 'Error', ' ', 'ID', ' ', '', '', 51, null, null, null) ;

CALL ImportDocCLS(982100, 9821, ' ', 'ACC_CLS', ' ', 'ID', ' ', '', '', 21, null, null, null) ;

CALL ImportDocCLS(981400, 9814, ' ', 'KSHK', ' ', 'ID', ' ', '', '', 14, null, null, null) ;

CALL ImportDocCLS(980200, 9802, ' ', 'kfsr', ' ', 'ID', ' ', '', '', 2, null, null, null) ;

CALL ImportDocCLS(980500, 9805, ' ', 'KCSR', ' ', 'ID', ' ', '', '', 5, null, null, null) ;

CALL ImportDocCLS(984100, 9841, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', '', '', 41, null, null, null) ;

CALL ImportDocCLS(981500, 9815, ' ', 'VALUECLS', ' ', 'ID', ' ', '', '', 15, null, null, null) ;

CALL ImportDocCLS(982800, 9828, ' ', 'FACT', ' ', 'ID', ' ', '', '', 28, null, null, null) ;

CALL ImportDocCLS(984800, 9848, ' ', 'PAYDESTINATIONCLS', ' ', 'ID', ' ', '', '', 48, null, null, null) ;

CALL ImportDocCLS(986900, 9869, ' ', 'DirectionCLS', ' ', 'ID', ' ', '', '', 69, null, null, null) ;

CALL ImportDocCLS(986200, 9862, ' ', 'OKATO', ' ', 'ID', ' ', '', '', 62, null, null, null) ;

CALL ImportDocCLS(988200, 9882, ' ', 'OKOPF', ' ', 'ID', ' ', '', '', 82, null, null, null) ;

CALL ImportDocCLS(988100, 9881, ' ', 'OKFS', ' ', 'ID', ' ', '', '', 81, null, null, null) ;

CALL ImportDocCLS(981600, 9816, ' ', 'MeansCLS', ' ', 'ID', ' ', '', '', 16, null, null, null) ;

CALL ImportDocCLS(985900, 9859, ' ', 'DepartmentCLS', ' ', 'ID', ' ', '', '', 59, null, null, null) ;

CALL ImportDocCLS(986500, 9865, ' ', 'BuhAccPlan', ' ', 'ID', ' ', '', '', 65, null, null, null) ;

CALL ImportDocCLS(986100, 9861, ' ', 'TenderObjects', ' ', 'ID', ' ', '', '', 61, null, null, null) ;

CALL ImportDocCLS(985000, 9850, ' ', 'RejectCLS', ' ', 'ID', ' ', '', '', 50, null, null, null) ;

CALL ImportDocCLS(987000, 9870, ' ', 'ProgramCode', ' ', 'ID', ' ', '', '', 70, null, null, null) ;

CALL ImportDocCLS(981200, 9812, ' ', 'RegionCLS', ' ', 'ID', ' ', '', '', 12, null, null, null) ;

CALL ImportDocCLS(982600, 9826, ' ', 'BUDGETACCOUNTS', ' ', 'ID', ' ', '', '', 26, null, null, null) ;

CALL ImportDocCLS(981700, 9817, ' ', 'REFCLS', ' ', 'ID', ' ', '', '', 17, null, null, null) ;

CALL ImportDocCLS(981000, 9810, ' ', 'SubKD', ' ', 'ID', ' ', '', '', 10, null, null, null) ;

CALL ImportDocCLS(980600, 9806, ' ', 'SUBKCSR', ' ', 'ID', ' ', '', '', 6, null, null, null) ;

CALL ImportDocCLS(980800, 9808, ' ', 'KESRSubCode', ' ', 'ID', ' ', '', '', 8, null, null, null) ;

CALL ImportDocCLS(986300, 9863, ' ', 'COLLATERALTYPE', ' ', 'ID', ' ', '', '', 63, null, null, null) ;

CALL ImportDocCLS(982000, 9820, ' ', 'ORG_CLS', ' ', 'ID', ' ', '', '', 20, null, null, null) ;

CALL ImportDocCLS(983400, 9834, ' ', 'ReportType', ' ', 'ID', ' ', '', '', 34, null, null, null) ;

CALL ImportDocCLS(985300, 9853, ' ', 'REESTRTYPE', ' ', 'ID', ' ', '', '', 53, null, null, null) ;

CALL ImportDocCLS(984900, 9849, ' ', 'MEANSTYPE', ' ', 'ID', ' ', '', '', 49, null, null, null) ;

CALL ImportDocCLS(982700, 9827, ' ', 'FinType', ' ', 'ID', ' ', '', '', 27, null, null, null) ;

CALL ImportDocCLS(984400, 9844, ' ', 'Org_AccDefaults', ' ', 'ID', ' ', '', '', 44, null, null, null) ;

CALL ImportDocCLS(960100, 9601, ' ', 'ORGANIZATIONS', ' ', 'ID', ' ', '', '', 1000, null, null, null) ;

CALL ImportDocCLS(960200, 9602, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 1001, null, null, null) ;

CALL ImportDocCLS(960400, 9604, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', '', 1003, null, null, null) ;

CALL ImportDocCLS(960300, 9603, ' ', 'BANKS', ' ', 'ID', ' ', '', '', 1002, null, null, null) ;

CALL ImportDocCLS(987100, 9871, ' ', 'BuhOperationCls', ' ', 'Id', ' ', '', '', 71, null, null, null) ;

CALL ImportDocCLS(987800, 9878, ' ', 'budgets_s', ' ', 'id', ' ', '', '', 78, null, null, null) ;

CALL ImportDocCLS(991400, 9914, '', 'DATAPACKETTYPES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991401, 9914, '', 'DATAPACKETCONTENT', ' ', 'ID', ' ', 'DATAPACKETTYPE', '', 0, null, null, null) ;

CALL ImportDocCLS(991500, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991501, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', 'ID', '', 0, null, null, null) ;

CALL ImportDocCLS(20001, 200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(30000, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30001, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190000, 1900, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190001, 1900, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(220000, 2200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(220001, 2200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991300, 9913, '', 'INTERFACES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991301, 9913, '', 'Permissions', ' ', 'ID', ' ', 'INTERFACEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(991302, 9913, '', 'LinkType', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991303, 9913, ' ', ' ', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(490200, 4902, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 526) ;

CALL ImportDocCLS(250400, 2504, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', '', 0, null, null, 314) ;

CALL ImportDocCLS(300100, 3001, '', 'TenderCaption', ' ', 'ID', ' ', '', '', 0, null, null, 230) ;

CALL ImportDocCLS(250401, 2504, '  ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(250402, 2504, '   ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(250403, 2504, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(300600, 3006, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 241) ;

CALL ImportDocCLS(250102, 2501, '  . ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(70202, 702, '', 'PAYDOCEXCHANGE', ' ', 'ID', ' ', 'PAYDOCREF', '', 0, null, null, null) ;

CALL ImportDocCLS(170101, 1701, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20900, 209, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 274) ;

CALL ImportDocCLS(300601, 3006, '  ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 241) ;

CALL ImportDocCLS(300602, 3006, '   ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300300, 3003, '', 'TenderResultCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(300101, 3001, ' ', 'TenderProduct', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 230) ;

CALL ImportDocCLS(300102, 3001, ' ', 'TenderLot', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300103, 3001, '   ', 'TENDERSOURCEORG', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300104, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300105, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300106, 3001, ' ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300107, 3001, '   ', 'TENDERSUPPLEMENTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300108, 3001, ',  ', 'TENDERSUPDOCUMENT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(370100, 3701, '', 'TenderObjects', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(520101, 5201, '', 'WritExecutionDetail', 'WritExecutionDetail', 'id', 'id', 'RecordIndex', '', 0, null, null, 556) ;

CALL ImportDocCLS(20901, 209, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(21000, 210, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 252) ;

CALL ImportDocCLS(21001, 210, ', ', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 252) ;

CALL ImportDocCLS(21002, 210, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 253) ;

CALL ImportDocCLS(991800, 9918, '', 'USERGENERATOR', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991801, 9918, '', 'USERGENERATORFIELDS', ' ', 'ID', ' ', 'GENREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992702, 9927, '   ', 'REMOTEINPUTRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(21202, 212, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(990802, 9908, ' ', 'STATE_DOCSTATES', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990803, 9908, '', 'STATE_JUMPS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990804, 9908, '', 'STATE_ACTIONS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992703, 9927, '   ', 'REMOTECLIENTACCOUNT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992000, 9920, '', 'BUHOPERATIONCLS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992001, 9920, '', 'BUHACCCORR', ' ', 'ID', ' ', 'BUHOPERATIONCLS', '', 0, null, null, null) ;

CALL ImportDocCLS(992100, 9921, '', 'BUDGETS_S', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992101, 9921, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992102, 9921, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(989000, 9890, ' ', 'BudAllocationCls', ' ', 'id', ' ', '', '', 90, null, null, null) ;

CALL ImportDocCLS(989100, 9891, ' ', 'PayPromiseCls', ' ', 'id', ' ', '', '', 91, null, null, null) ;

CALL ImportDocCLS(550300, 5503, '', 'ReplacementClsCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550301, 5503, '   ', 'ReplacementClsDetail', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(550302, 5503, ' ', 'ReplacementClsDetailInfo', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(250302, 2503, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'EXECUTIONREF', '', 0, null, null, 308) ;

CALL ImportDocCLS(181400, 1814, '', 'BANKEXCH_LS_KB', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(180900, 1809, '', 'BANKEXCH_SUBSTITUTION', 'BANKEXCH_SUBSTITUTION', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181500, 1815, '', 'BANKEXCH_KO_SALDO', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992900, 9929, '', 'BudStruct', 'BudStruct', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992201, 9922, '', 'ARCHIVEDOCPARAMS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(992400, 9924, '', 'SIGNS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(480101, 4801, '', 'GeneralDocsDetail', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992502, 9925, '', 'CARDSDETAIL_KESR', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(250203, 2502, ' ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 304) ;

CALL ImportDocCLS(250404, 2504, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', '', 0, null, null, 318) ;

CALL ImportDocCLS(520102, 5201, '2', 'WritExecutionNotify', 'WritExecutionNotify', 'id', 'id', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(989200, 9892, ' ', 'ArchiveDocType', ' ', 'id', ' ', '', '', 92, null, null, null) ;

CALL ImportDocCLS(480100, 4801, '', 'GeneralDocuments', ' ', 'ID', ' ', '', '', 0, null, null, 528) ;

CALL ImportDocCLS(992600, 9926, '', 'WritNotifyCls', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992601, 9926, '', 'WRITNOTIFYCLSDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992602, 9926, ' ', 'WritNotifyClsPart', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(31600, 316, '', 'ManagerBid', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20902, 209, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(992704, 9927, '  + /', 'DUALRIGHTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992705, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992706, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(990400, 9904, '', 'CONTACTPERSONS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181601, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992707, 9927, '', 'SIGNCERTIFICATE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992708, 9927, '  ', 'SIGNDOCUMENTSGROUP', ' ', 'ID', ' ', 'CLIENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(510100, 5101, '', 'StoredAttributesCaption', 'StoredAttributesCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(510101, 5101, '', 'StoredAttributesDetail', 'StoredAttributesDetail', 'id', 'id', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250405, 2504, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(993000, 9930, '', 'AUTOSANCTIONDATA', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301000, 3010, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 242) ;

CALL ImportDocCLS(970200, 9702, ' ', 'AnalyticalGroupIFS', 'AnalyticalGroupIFS', 'ID', 'ID', '', '', 102, null, null, null) ;

CALL ImportDocCLS(970100, 9701, ' ', 'AnalyticalGroupKD', 'AnalyticalGroupKD', 'ID', 'ID', '', '', 101, null, null, null) ;

CALL ImportDocCLS(181800, 1818, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301100, 3011, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 243) ;

CALL ImportDocCLS(301101, 3011, ' ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 243) ;

CALL ImportDocCLS(300500, 3005, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 240) ;

CALL ImportDocCLS(181801, 1818, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181802, 1818, '', 'OOS_CONTRACT_PRODUCTS', 'OOS_CONTRACT_PRODUCTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181803, 1818, '', 'OOS_CONTRACTPROCEDURE', 'OOS_CONTRACTPROCEDURE', 'ID', 'ID', 'RegNum', 'RegNum', 0, null, null, null) ;

CALL ImportDocCLS(989700, 9897, ' ', 'ContractCostsCls', 'ContractCostsCls', 'id', 'id', '', '', 97, null, null, null) ;

CALL ImportDocCLS(960101, 9601, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(989800, 9898, ' ', 'PURCHASETYPE ', 'PURCHASETYPE ', 'id', 'id', '', '', 98, null, null, null) ;

CALL ImportDocCLS(21300, 213, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 277) ;

CALL ImportDocCLS(21301, 213, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 277) ;

CALL ImportDocCLS(21400, 214, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 278) ;

CALL ImportDocCLS(21401, 214, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 278) ;

CALL ImportDocCLS(993200, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993201, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21500, 215, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 279) ;

CALL ImportDocCLS(21501, 215, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 279) ;

CALL ImportDocCLS(250204, 2502, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(181900, 1819, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181901, 1819, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(182000, 1820, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(182001, 1820, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181804, 1818, '', 'OOS_ATTACHMENTS', 'OOS_ATTACHMENTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250406, 2504, '', 'Suppliers', 'Suppliers', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(540200, 5402, '', 'EPBSExportLogCaption', 'EPBSExportLogCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(540201, 5402, '', 'EPBSExportLogDetail', 'EPBSExportLogDetail', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(970900, 9709, ' ', 'TargetCls', ' ', 'ID', ' ', '', '', 109, null, null, null) ;

CALL ImportDocCLS(985400, 9854, ' ', 'InvestObject', ' ', 'ID', ' ', '', '', 54, null, null, null) ;

CALL ImportDocCLS(182100, 1821, '', 'PayDocExchange', 'PayDocExchange', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(470100, 4701, '', 'SignCertificate', 'SignCertificate', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971000, 9710, ' ', 'NATIONALPROJECT', 'NATIONALPROJECT', 'ID', 'ID', '', '', 110, null, null, null) ;

CALL ImportDocCLS(21600, 216, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 280) ;

CALL ImportDocCLS(21601, 216, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 280) ;

CALL ImportDocCLS(21700, 217, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 281) ;

CALL ImportDocCLS(21701, 217, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) ;

CALL ImportDocCLS(21702, 217, '2', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) ;

CALL ImportDocCLS(993300, 9933, '', 'ClsCorr', 'ClsCorr', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993301, 9933, '', 'ClsCorrColumns', 'ClsCorrColumns', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993400, 9934, '', 'ClsCorr', 'ClsCorr', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993401, 9934, '', 'ClsCorrValues', 'ClsCorrValues', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971100, 9711, ' ', 'RegProjectResult', 'RegProjectResult', 'ID', 'ID', '', '', 111, null, null, null) ;

CALL ImportDocCLS(21800, 218, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 282) ;

CALL ImportDocCLS(21801, 218, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 282) ;

CALL ImportDocCLS(32500, 325, '', 'FACIALFINCAPTION', 'FACIALFINCAPTION', 'ID', 'ID', '', '', 0, null, null, 283) ;

CALL ImportDocCLS(32501, 325, '', 'FACIALFINDETAIL', 'FACIALFINDETAIL', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, 283) ;

CALL ImportDocCLS(182400, 1824, '', 'PayDocExchange ', 'PayDocExchange ', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(182401, 1824, '', 'ED_OUT_FACIALACC', 'ED_OUT_FACIALACC', 'ID', 'ID', 'ELDOCREF', '', 0, null, null, null) ;

CALL ImportDocCLS(182500, 1825, '', 'PayDocExchange', 'PayDocExchange', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(971300, 9713, ' ', 'PayTargetFunds', 'PayTargetFunds', 'ID', 'ID', '', '', 113, null, null, null) ;

CALL ImportDocCLS(971200, 9712, ' ', 'IncomeTargetFunds', 'IncomeTargetFunds', 'ID', 'ID', '', '', 112, null, null, null) ;

CALL ImportDocCLS(971400, 9714, ' ', 'AnalyticalPartition', 'AnalyticalPartition', 'ID', 'ID', '', '', 114, null, null, null) ;

CALL ImportDocCLS(971600, 9716, ' ', 'PaymentCodeType', 'PaymentCodeType', 'ID', 'ID', '', '', 116, null, null, null) ;

CALL ImportDocCLS(993500, 9935, '', 'CoFinancingLevel', ' ', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993600, 9936, '', 'RemoteMailMessages', ' ', 'ID', ' ', '', '', 0, 20902, null, null) ;

CALL ImportDocCLS(993601, 9936, '', 'RemoteMailClientMessages', ' ', 'ID', ' ', 'MessageRef', '', 0, 20908, null, null) ;

DROP PROCEDURE ImportDocCLS
/

COMMIT WORK
/


CREATE OR REPLACE PROCEDURE ImportField (
   ID_                NUMBER,
   NAME_              VARCHAR2,
   ITFFIELDNAME_      VARCHAR2,
   NOTE_              VARCHAR2,
   TEMPLATEFIELD_     VARCHAR2,
   ISBUDGET_          NUMBER,
   DOCTYPEREF_        NUMBER,
   DETAILNUMBER_      NUMBER,
   ONLYREAD_          NUMBER,
   ReportFieldName_   VARCHAR2,
   KIND_	      NUMBER,
   FIELDINFOREF_      NUMBER,
   CONTAINERREF_      NUMBER, 
   ATTRFIELDKIND_     NUMBER,
   ATTRIBUTENAME_     VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentFields
    WHERE (ID = ID_);

   IF (IDExists$ <> 0) THEN
      UPDATE DocumentFields
         SET NAME = NAME_,
             ITFFIELDNAME = ITFFIELDNAME_,
             NOTE = NOTE_,
             TEMPLATEFIELD = TEMPLATEFIELD_,
             ISBUDGET = ISBUDGET_,
             DOCTYPEREF = DOCTYPEREF_,
             DETAILNUMBER = DETAILNUMBER_,
             ONLYREAD = ONLYREAD_,
             ReportFieldName = ReportFieldName_,
			       FIELDINFOREF = FIELDINFOREF_, 
             CONTAINERREF = CONTAINERREF_, 
             ATTRFIELDKIND = ATTRFIELDKIND_,
             ATTRIBUTENAME = ATTRIBUTENAME_
       WHERE (ID = ID_)
         AND NOT (
                      (
                          (
                           (NAME IS NOT NULL AND NAME_ IS NOT NULL) AND
                           (UPPER (NAME) = UPPER (NAME_))
                          )
                       OR (NAME IS NULL AND NAME_ IS NULL)
                      )

                  AND (
                          (
                           (ITFFIELDNAME_ IS NOT NULL AND ITFFIELDNAME IS NOT NULL) AND
                           (UPPER (ITFFIELDNAME_) = UPPER (ITFFIELDNAME))
                          )
                       OR (ITFFIELDNAME_ IS NULL AND ITFFIELDNAME IS NULL)
                      )
                      
                  AND (
                          (
                           (NOTE IS NOT NULL AND NOTE_ IS NOT NULL) AND
                           (UPPER (NOTE) = UPPER (NOTE_))
                          )
                       OR (NOTE IS NULL AND NOTE_ IS NULL)
                      )
                  AND (UPPER (TEMPLATEFIELD) = UPPER (TEMPLATEFIELD_))
                  AND (
                          (
                           (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                           (ISBUDGET = ISBUDGET_)
                          )
                       OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                      )
                  AND (
                          (
                           (FIELDINFOREF IS NOT NULL AND FIELDINFOREF_ IS NOT NULL) AND
                           (FIELDINFOREF = FIELDINFOREF_)
                          )
                       OR (FIELDINFOREF IS NULL AND FIELDINFOREF_ IS NULL)
                      )
                  AND (
                          (
                           (CONTAINERREF IS NOT NULL AND CONTAINERREF_ IS NOT NULL) AND
                           (CONTAINERREF = CONTAINERREF_)
                          )
                       OR (CONTAINERREF IS NULL AND CONTAINERREF_ IS NULL)
                      )   
                  AND (
                          (
                           (ATTRFIELDKIND IS NOT NULL AND ATTRFIELDKIND_ IS NOT NULL) AND
                           (ATTRFIELDKIND = ATTRFIELDKIND_)
                          )
                       OR (ATTRFIELDKIND IS NULL AND ATTRFIELDKIND_ IS NULL)
                      )
                  AND (
                          (
                           (ATTRIBUTENAME_ IS NOT NULL AND ATTRIBUTENAME IS NOT NULL) AND
                           (UPPER (ATTRIBUTENAME_) = UPPER (ATTRIBUTENAME))
                          )
                       OR (ATTRIBUTENAME_ IS NULL AND ATTRIBUTENAME IS NULL)
                      )
                  AND (DOCTYPEREF = DOCTYPEREF_)
                  AND (DETAILNUMBER = DETAILNUMBER_)
                  AND (ONLYREAD = ONLYREAD_)
                  AND (
                          (
                           (ReportFieldName IS NOT NULL AND ReportFieldName_ IS NOT NULL) AND
                           (UPPER (ReportFieldName) = UPPER (ReportFieldName_))
                          )
                       OR (ReportFieldName IS NULL AND ReportFieldName_ IS NULL)
                      )
                 );
   ELSE
      INSERT INTO DocumentFields
                  (ID, NAME, ITFFIELDNAME, NOTE, TEMPLATEFIELD,
                   ISBUDGET, DOCTYPEREF, DETAILNUMBER, ONLYREAD, ReportFieldName, FIELDINFOREF, CONTAINERREF, ATTRFIELDKIND, ATTRIBUTENAME
                  )
           VALUES (ID_, NAME_, ITFFIELDNAME_, NOTE_, TEMPLATEFIELD_,
                   ISBUDGET_, DOCTYPEREF_, DETAILNUMBER_, ONLYREAD_, ReportFieldName_, FIELDINFOREF_, CONTAINERREF_, ATTRFIELDKIND_, ATTRIBUTENAME_
                  );
   END IF;

   FOR tab_rec IN (
                   SELECT ID
                     FROM DocumentFields
                    WHERE (ID <> ID_)
                      AND (DOCTYPEREF = DOCTYPEREF_)
                      AND (
                              (
                               (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                               (ISBUDGET = ISBUDGET_)
                              )
                           OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                          )
                      AND (DETAILNUMBER = DETAILNUMBER_)
              AND ( /*      ,       ,       */
                            (
                             ((ITFFIELDNAME_ IS NULL)or(ITFFIELDNAME_=' '))
                 and not((TEMPLATEFIELD_ IS NULL)or(TEMPLATEFIELD_=' '))
                 and(TEMPLATEFIELD is NOT null) and (UPPER(TEMPLATEFIELD)=UPPER(TEMPLATEFIELD_))
                            )
                    or (
                        not ((ITFFIELDNAME_ IS NULL) or (ITFFIELDNAME_=' '))
                                and (ITFFIELDNAME IS NOT NULL) and (UPPER(ITFFIELDNAME)=UPPER(ITFFIELDNAME_)))
                            )
                       )
   LOOP
      UPDATE State_OpenFields
         SET DOCFIELDREF = ID_
       WHERE (DOCFIELDREF = tab_rec.ID);

      UPDATE DOCLOCKFIELDS
         SET FIELDREF = ID_
       WHERE (FIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET PARENTFIELDREF = ID_
      WHERE (PARENTFIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET CHILDFIELDREF = ID_
      WHERE (CHILDFIELDREF = tab_rec.ID);

      DELETE FROM DocumentFields
            WHERE (ID = tab_rec.ID);
   END LOOP;
END;
/

CREATE OR REPLACE PROCEDURE DeleteFields (ID$ NUMBER) IS
BEGIN
  DELETE FROM State_OpenFields
  WHERE (docfieldref = ID$);
  DELETE FROM DOCLOCKFIELDS
  WHERE (fieldref = ID$);

  DELETE FROM STATE_JUMPCONTROL
  WHERE STATICLINKREF IN(SELECT ID FROM staticlinks
                           WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$));
  DELETE FROM staticlinks
  WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$);
  
  DELETE FROM DOCUMENTTEMPLATEFIELDS
  WHERE (FIELDS=ID$);

  DELETE FROM STOREDATTRIBUTESDETAIL
  WHERE (ATTRIBUTEFIELD = ID$) or (CONTAINERFIELD = ID$);  

  DELETE FROM DocumentFields
  WHERE (id = ID$);
END;
/

CREATE OR REPLACE PROCEDURE INSERTCONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER,
  NOTE_          VARCHAR2,
  VARCHARVALUE_  VARCHAR2,
  DOUBLEVALUE_   NUMBER,
  INTVALUE_      INTEGER,
  EDITDOCCODE_   INTEGER
) IS
  IDEXISTS$ NUMBER;
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM IntConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO INTCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,INTVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE INTCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 8) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM VarcharConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO VARCHARCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,VARCHARVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE VARCHARCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 5) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM RealConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO REALCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,DOUBLEVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE REALCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;   
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DELETECONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER
) IS
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    UPDATE IntConst
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
  IF (CONSTTYPE_ = 8) THEN
    UPDATE VARCHARCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_); 
  END IF;
  IF (CONSTTYPE_ = 5) THEN
    UPDATE REALCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
END;
/

--       
ALTER TRIGGER TR_INTCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 DISABLE
/

--     
--   14 /, (1)
CALL ImportField(21411050, '', 'Note', '', 'Note', 1, 214, 1, 0, '', 0, 17431, 0, 0, '') ;

--   14 /, +(2)
CALL ImportField(21411047, '  ', 'SUMMAYEAR2', '  ', 'SUMMAYEAR2', 2, 214, 1, 0, '', 0, 17458, 0, 0, '') ;

CALL ImportField(21411049, '  ', 'SUMMAYEAR3', '  ', 'SUMMAYEAR3', 2, 214, 1, 0, '', 0, 17459, 0, 0, '') ;

--   14 /, (1)
CALL ImportField(21511055, '', 'Note', '', 'Note', 1, 215, 1, 0, '', 0, 17431, 0, 0, '') ;

--   , (0)
CALL ImportField(30401041, '  .', 'SourceBudgetPromiseAgrRNum', '  .', 'SourceBudgetPromiseAgrReestrNum', 0, 304, 1, 1, '', 0, null, 0, 0, '') ;

--  , (0)
CALL ImportField(32400253, '  ()', 'CREATEDATE', '  ()', 'CreateDate', 0, 324, 0, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(32410186, '  ()', 'CREATEDATE', '  ()', 'CreateDate', 1, 324, 0, 1, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(32510150, ' ', 'BidDate', ' ', 'BidDate', 2, 325, 0, 0, '', 0, 24730, 0, 0, '') ;

--  (), (0)
CALL ImportField(190101195, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190101221, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 1901, 1, 0, '', 0, 22390, 0, 0, '') ;

--    (), (0)
CALL ImportField(190201195, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190201224, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 1902, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (0)
CALL ImportField(190301202, ' ', 'TargetCls', '  ()', 'TargetClsKey', 0, 1903, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(190301203, ' ', 'TargetClsCode', ' ', 'TargetCls', 0, 1903, 1, 0, '', 0, 22390, 0, 0, '') ;

--    (), (1)
CALL ImportField(190611116, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1906, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(190611117, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1906, 1, 1, '', 0, 40783, 0, 0, '') ;

--   , +(2)
CALL ImportField(250312049, '', 'InvestObject', '', 'InvestObject', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312050, '', 'InvestObjectCode', '', 'InvestObjectCode', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

--  - , +(2)
CALL ImportField(301111043, '', 'InvestObject', '', 'InvestObject', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111044, '', 'InvestObjectCode', '', 'InvestObjectCode', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(470110026, 'C  ', 'UserRef', '', 'UserRef', 2, 4701, 0, 0, 'C', 0, null, 0, 0, 'C') ;

--   , +(2)
CALL ImportField(988410039, '', 'TRANSFERTKIND', '', ' ', 2, 9884, 0, 0, '', 0, 31753, 0, 0, '') ;

--  , (1)
CALL ImportField(991610230, ' \    ,  ', '_', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0, '') ;

CALL InsertConst(32, 50, 3, ' \    ,  ', '', 0, 0, 9916) ;

--  , +(2)
CALL ImportField(993510001, ' ', 'TargetCls', '', ' ', 2, 9935, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993510002, ' ', 'TargetClsCode', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510003, ' ', 'BudgetLevel', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510004, ' ', 'Percent', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510005, ' ', 'MeansType', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510006, '', 'KCSR', '', ' ', 2, 9935, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993510007, '', 'KCSRCode', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510008, ' ', 'CommDirectionExpenceCls', '', ' ', 2, 9935, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993510009, ' ', 'CommDirectionExpenceClsCode', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510010, '  ', 'TransfertCls', '', ' ', 2, 9935, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993510011, '  ', 'TransfertClsCode', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993510012, '', 'BudgetRef', '', ' ', 2, 9935, 0, 0, '', 0, null, 0, 0, '') ;

--     , (1)
CALL ImportField(993610001, ' ', 'ID', '', ' ', 1, 9936, 0, 1, '', 0, 20903, 0, 0, '') ;

CALL ImportField(993611001, ' ', 'ID', ' ()', ' ', 1, 9936, 1, 1, '', 0, 20909, 0, 0, '') ;

--       
ALTER TRIGGER TR_INTCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 ENABLE
/

DROP PROCEDURE ImportField
/

/*      */
ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 DISABLE
/

Update TB_DocumentFields df
set documentcls=doctyperef*100+detailnumber
where (detailnumber<100)and(documentcls is null)
 and(exists(select dc.id from documentcls dc where id=df.doctyperef*100+df.detailnumber))
/

ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 ENABLE
/

DROP PROCEDURE DeleteFields
/

DROP PROCEDURE InsertConst
/

DROP PROCEDURE DELETECONST
/




CREATE OR REPLACE PROCEDURE DOCLOCK_IMPORT(
  NAME_              VARCHAR2,
  LOCKMASK_          NUMBER,
  DOCREF_            NUMBER,
  DETAILNUM_         NUMBER,
  RUNPOS_            NUMBER,
  LOCKACTION_        NUMBER,
  USERIGHTS_        NUMBER,
  FORMULA_           VARCHAR2,
  FORDELETE_         NUMBER,
  ISSYSTEM_          NUMBER,
  NOTE_              VARCHAR2,
  FORINSERT_         NUMBER,
  VALIDATEMESSAGE_ VARCHAR2,
  VALIDATELEVEL_   NUMBER,
  VALIDATEFILTER_  VARCHAR2,
  ISBUDGET_ NUMBER,
  DEFAULTVALUE_ VARCHAR2)
IS
  DOCLOCKID$ Number(10);
BEGIN
   BEGIN
     SELECT ID
     INTO DOCLOCKID$
     FROM DOCLOCK
     WHERE (DOCREF = DOCREF_) AND(DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       DOCLOCKID$ := NULL;  
   END;
   
   IF (DOCLOCKID$ is not null) THEN
     IF (ISSYSTEM_ = 3) THEN
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_,
         USERIGHTS = USERIGHTS_,
         DEFAULTVALUE = DEFAULTVALUE_
       WHERE ID = DOCLOCKID$;  
     ELSE
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_,
         DEFAULTVALUE = DEFAULTVALUE_
       WHERE ID = DOCLOCKID$;    
     END IF;  
   ELSE
     INSERT INTO DOCLOCK
       (ISBUDGET,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORMULA,FORDELETE,ISSYSTEM,NOTE,FORINSERT,VALIDATEMESSAGE,VALIDATELEVEL,VALIDATEFILTER,DEFAULTVALUE)
     VALUES
       (ISBUDGET_,NAME_,LOCKMASK_,DOCREF_,DETAILNUM_,RUNPOS_,LOCKACTION_,USERIGHTS_,FORMULA_,FORDELETE_,ISSYSTEM_,NOTE_,FORINSERT_,VALIDATEMESSAGE_,VALIDATELEVEL_,VALIDATEFILTER_,DEFAULTVALUE_);
   END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(
  NAME_      VARCHAR2,
  DOCREF_    NUMBER,
  DETAILNUM_ NUMBER,
  FIELDREF_  NUMBER,
  ISBUDGET_ NUMBER)
IS
  NID$ NUMBER(10);
  cnt$ number(10);
BEGIN
  BEGIN
    SELECT ID
    INTO NID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      NID$ := NULL;  
  END;

  IF (NID$ is not null) THEN
    CNT$ := 0;
    SELECT count(ID)
    into cnt$
    FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    
    IF (cnt$ = 0) THEN
      INSERT INTO DOCLOCKFIELDS
        (DOCLOCKREF,FIELDREF,ISSYSTEM)
      VALUES
        (NID$,FIELDREF_,1);
    ELSE
      UPDATE DOCLOCKFIELDS SET
        ISSYSTEM = 1
      WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    END IF;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCK_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCK
    WHERE ID = DOCLOCKID$;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, CANCHANGEFIELDS_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION  
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;  

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = DOCLOCKID$) AND ((ISSYSTEM = 1) OR ((ISSYSTEM = 0) AND (CANCHANGEFIELDS_ = 0) ));
  END IF;
END;
/

-- 
CALL DOCLOCK_DELETE('      ',200, 1, 1) ;

CALL DOCLOCK_DELETE('     ',200, 1, 1) ;

CALL DOCLOCK_DELETE('     ',200, 1, 0) ;

CALL DOCLOCK_DELETE('     ',200, 1, 2) ;

CALL DOCLOCK_DELETE('      ',200, 1, 0) ;

CALL DOCLOCK_DELETE('     . ',200, 1, 1) ;

CALL DOCLOCK_DELETE('     . ',200, 1, 0) ;

CALL DOCLOCK_DELETE('  ',218, 1, 2) ;

CALL DOCLOCK_DELETE('      ',218, 1, 2) ;

CALL DOCLOCK_DELETE('      ',300, 0, 1) ;

CALL DOCLOCK_DELETE('      ',300, 0, 0) ;

CALL DOCLOCK_DELETE('      ',300, 1, 1) ;

CALL DOCLOCK_DELETE('      ',300, 1, 0) ;

CALL DOCLOCK_DELETE('     ',300, 1, 0) ;

CALL DOCLOCK_DELETE('     ',300, 1, 1) ;

CALL DOCLOCK_DELETE('     . ',300, 1, 1) ;

CALL DOCLOCK_DELETE('     . ',300, 1, 0) ;

CALL DOCLOCK_DELETE('    (.)  ',308, 1, 0) ;

CALL DOCLOCK_DELETE('    (.)  ',308, 1, 1) ;

CALL DOCLOCK_DELETE('     ',308, 1, 1) ;

CALL DOCLOCK_DELETE('     ',308, 1, 0) ;

CALL DOCLOCK_DELETE('      ',2502, 2, 2) ;

CALL DOCLOCK_DELETE('     ',2502, 2, 2) ;

CALL DOCLOCK_DELETE('      ',2503, 2, 2) ;

CALL DOCLOCK_DELETE('     ',2503, 2, 2) ;

CALL DOCLOCK_DELETE('      ',2504, 2, 2) ;

CALL DOCLOCK_DELETE('     ',2504, 2, 2) ;

CALL DOCLOCK_IMPORT('     . ',0,200,1,0,11,0,'(("_.",[20011008]))  (("_.",[20011027]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 200, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',200,1,20011015,1) ;

CALL DOCLOCK_IMPORT('     . ',0,200,1,0,11,0,'(("_.",[20001008]))  (("_.",[20001027]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 200, 1, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',200,1,20001015,0) ;

CALL DOCLOCK_IMPORT('     . .',0,200,1,0,11,0,'("_.",[20011008])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',200,1,20011027,1) ;

CALL DOCLOCK_IMPORT('     . .',0,200,1,0,11,0,'("_.",[20001008])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',200,1,20001027,0) ;

CALL DOCLOCK_IMPORT('    / ,',0,200,1,0,11,0,' ((=204)(=212)  (=218))',0,3,'  \,  ,       ',0,'    / , ,   ,    , / , /         ',null,'([984110041]=0)([984110045]=0)([984110046]=0)([984110056]=0)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    / ,', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,',200,1,20011008,1) ;

CALL DOCLOCK_IMPORT('    / ,',0,200,1,0,11,0,' ((=204)(=212)  (=218))',0,3,'  \,  ,       ',0,'    / , ,   ,    , /       ',null,'([984110041]=0)([984110045]=0)([984110046]=0)([984110056]=0)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    / ,', 200, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,',200,1,20001008,0) ;

CALL DOCLOCK_IMPORT('   /',0,204,1,0,11,0,'',0,1,'   /  . ',0,'      / , ,   ,      / ',null,'([984110041] <> 0)  ([984110045] <> 0)  ([984110046] <> 0)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('   /', 204, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   /',204,1,20411033,1) ;

CALL DOCLOCK_IMPORT('   /',0,204,1,0,11,0,'',0,1,'   /  .',0,'      / , ,   ,      / ',null,'([984110041] <> 0)  ([984110045] <> 0)  ([984110046] <> 0)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('   /', 204, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   /',204,1,20401054,0) ;

CALL DOCLOCK_IMPORT('     .',0,218,1,0,11,0,'',0,3,'      ',0,'         .',null,'[984110056]=1',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     .', 218, 1, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     .',218,1,21811067,2) ;

CALL DOCLOCK_IMPORT('     (2)',0,300,0,0,11,0,'(<>323)  (("/._",[30010021]) = 0)    ((("/.",[30010021]) <> 0)  (30,44,3) = 1)   (("/._",[30010021]) = 0)  (("/._",[30010021]) = 0)  (("/.",[30010021]) = 0)',0,1,'          () ,   , ,  /c  /c   ',0,'         ", ", "  ,    ", "", " " ',null,'(([984110041] = 1)  ([984110045] = 1)  ([984110046]=1)  ([984110056] = 1) ) 
( ([984110044] = 0)  ([984110042] = 0)  ([984110043] = 0))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     (2)', 300, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     (2)',300,0,30010008,1) ;

CALL DOCLOCK_IMPORT('     (2)',0,300,0,0,11,0,'(<>323)  (("/._",[30000021]) = 0)   ((("/.",[30000021]) <> 0)  (30,44,3) = 1)   (("/._",[30000021]) = 0)  (("/._",[30000021]) = 0)  (("/.",[30000021]) = 0)',0,1,'          () ,   , ,  /c  /c   ',0,'         ", "  "  ,    " ',null,'(([984110041] = 1)  ([984110045] = 1)  ([984110046]=1)  ([984110056] = 1)) 
( ([984110044] = 0)  ([984110042] = 0)  ([984110043] = 0) )',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     (2)', 300, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     (2)',300,0,30000008,0) ;

CALL DOCLOCK_IMPORT('      (4)',0,300,0,0,11,0,'("/.",[30010021])=1',0,1,'     .        .',0,'     .        .',null,'[984110056]=1',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      (4)', 300, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      (4)',300,0,30010008,1) ;

CALL DOCLOCK_IMPORT('      (4)',0,300,0,0,11,0,'("/.",[30000021])=1',0,1,'     .        .',0,'     .        .',null,'[984110056]=1',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      (4)', 300, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('      (4)',300,0,30000008,0) ;

CALL DOCLOCK_IMPORT('     ',0,300,0,0,11,0,'(("/.",[30010021]) = 0) (("/.",[30010021])=0) (("/.",[30010021]) = 0)',0,1,'            ,   /c   ", "  "  ,    "  ""',0,'     , ,   ,             ',null,'(([984110042] = 1)  ([984110044] = 1)  ([984110043] = 1)  ([984110056] = 1)) 
( ([984110044] = 0)  ([984110042] = 0)  ([984110041] = 0)  
    ([984110045] = 0)  ([984110046] = 0)  ([984110043] = 0) )',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,0,30010008,1) ;

CALL DOCLOCK_IMPORT('     ',0,300,0,0,11,0,'(("/.",[30000021]) = 0)  (("/.",[30000021])=0)  (("/.",[30000021]) = 0)',0,1,'            ,   /c   ", "  "  ,    "  ""',0,'     , ,          ',null,'(([984110042] = 1)  ([984110044] = 1)  ([984110043] = 1)  ([984110056] = 1)) 
( ([984110044] = 0)  ([984110042] = 0)  ([984110041] = 0)  
    ([984110045] = 0)  ([984110046] = 0)  ([984110043] = 0) )',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 0, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,0,30000008,0) ;

CALL DOCLOCK_IMPORT('     . ',0,300,1,0,11,0,'(("_.",[30010008]))  (("_.",[30011035]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 300, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',300,1,30011023,1) ;

CALL DOCLOCK_IMPORT('     . ',0,300,1,0,11,0,'(("_.",[30000008]))  (("_.",[30001035]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 300, 1, 0, 0) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',300,1,30001023,0) ;

CALL DOCLOCK_IMPORT('     . .',0,300,1,0,11,0,'("_.",[30010008])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',300,1,30011035,1) ;

CALL DOCLOCK_IMPORT('     . .',0,300,1,0,11,0,'("_.",[30000008])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 300, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',300,1,30001035,0) ;

CALL DOCLOCK_IMPORT('     , ',0,300,1,0,11,0,'(("_._",[30010008])    ("_._",[30010008])    ("_.",[30010008]))  ( in(0323,0324))',0,1,' \ ,         2,3,4,7,8;     ,           5,6,9;   \        7  8.',0,'         ',null,'(("_._",.[30010008])
 (([984910001] between 2  4)([984910001] between 7  8)))

(("_.",.[30010008])
 ([984910001] between 7  8))

(("_._",.[30010008])
 (([984910001] between 5  6)([984910001] = 9)))',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',300,1,30011035,1) ;

CALL DOCLOCK_IMPORT('     , ',0,300,1,0,11,0,'(("_._",[30000008])    ("_._",[30000008])    ("_.",[30000008]))  ( in(0323,0324))',0,1,' \ ,         2,3,4,7,8;     ,           5,6,9;   \        7  8.',0,'         ',null,'(("_._",.[30000008])
 (([984910001] between 2  4)([984910001] between 7  8)))

(("_.",.[30000008])
 ([984910001] between 7  8))

(("_._",.[30000008])
 (([984910001] between 5  6)([984910001] = 9)))',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     , ', 300, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',300,1,30001035,0) ;

CALL DOCLOCK_IMPORT('     . ',0,308,1,0,11,0,'(("_.",[30811014]))  (("_.",[30811024]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 308, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',308,1,30811081,1) ;

CALL DOCLOCK_IMPORT('     . ',0,308,1,0,11,0,'(("_.",[30801026]))  (("_.",[30801035]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 308, 1, 0, 0) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',308,1,30801218,0) ;

CALL DOCLOCK_IMPORT('    (.) . .',0,308,1,0,11,0,'("_.",[30810064])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('    (.) . .', 308, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    (.) . .',308,1,30811024,1) ;

CALL DOCLOCK_IMPORT('    (.) . .',0,308,1,0,11,0,'("_.",[30800055])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',0,'') ;

CALL DOCLOCKFIELDS_DELETE('    (.) . .', 308, 1, 0, 0) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    (.) . .',308,1,30801035,0) ;

CALL DOCLOCK_IMPORT('  ',0,325,0,0,11,0,'',0,3,'',0,'',null,'[993010003] like ''0325%''',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 325, 0, 0, 2) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',325,0,32510137,2) ;

CALL DOCLOCK_IMPORT('  ',0,325,0,0,12,0,'',0,3,'',0,'',null,'',2,'') ;

CALL DOCLOCKFIELDS_DELETE('  ', 325, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',325,0,32510146,2) ;

CALL DOCLOCK_IMPORT('     ',0,1900,1,0,11,0,' <> 1904',0,3,'',0,'',null,'[987910012] = 5',0,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 1900, 1, 0, 0) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1900,1,190001040,0) ;

CALL DOCLOCK_IMPORT('     ',0,1900,1,0,11,0,' <> 1904',0,3,'',0,'',null,'[987910012] = 5',1,'') ;

CALL DOCLOCKFIELDS_DELETE('     ', 1900, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',1900,1,190011043,1) ;

CALL DOCLOCK_IMPORT('      ',0,1900,1,0,11,0,' <> 1904',0,3,'',0,'',null,'[988410039] = 5',1,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 1900, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',1900,1,190011002,1) ;

CALL DOCLOCK_IMPORT('      ',0,1900,1,0,11,0,' <> 1904',0,3,'',0,'',null,'[988410039] = 5',0,'') ;

CALL DOCLOCKFIELDS_DELETE('      ', 1900, 1, 0, 0) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',1900,1,190001002,0) ;

CALL DOCLOCK_IMPORT('     . ',0,2502,2,0,11,0,'(("_.",[250212035]))  (("_.",[250212025]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 2502, 2, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',2502,2,250212056,2) ;

CALL DOCLOCK_IMPORT('     . .',0,2502,2,0,11,0,'("_.",[250212035])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 2502, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',2502,2,250212025,2) ;

CALL DOCLOCK_IMPORT('',0,2502,2,0,11,0,'',0,1,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[250212043], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 2502, 2, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',2502,2,250212097,1) ;

CALL DOCLOCK_IMPORT('     . ',0,2503,2,0,11,0,'(("_.",[250312005]))  (("_.",[250312015]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 2503, 2, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',2503,2,250312051,2) ;

CALL DOCLOCK_IMPORT('     . .',0,2503,2,0,11,0,'("_.",[250312005])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 2503, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',2503,2,250312015,2) ;

CALL DOCLOCK_IMPORT('',0,2503,2,0,11,0,'',0,1,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[250312010], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 2503, 2, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',2503,2,250312089,1) ;

CALL DOCLOCK_IMPORT('     . ',0,2504,2,0,11,0,'(("_.",[250412043]))  (("_.",[250412030]) in (5,6,9))',0,1,'     .        5, 6  9            .',0,'     .        5, 6  9            .',null,'[988910010] in (1,2)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . ', 2504, 2, 0, 2) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     . ',2504,2,250412055,2) ;

CALL DOCLOCK_IMPORT('     . .',0,2504,2,0,11,0,'("_.",[250412043])',0,1,'     .         2, 3, 5, 6, 8, 9',0,'     .         2, 3, 5, 6, 8, 9',null,'[984910001] in (2, 3, 5, 6, 8, 9)',2,'') ;

CALL DOCLOCKFIELDS_DELETE('     . .', 2504, 2, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     . .',2504,2,250412030,2) ;

CALL DOCLOCK_IMPORT('',0,2504,2,0,11,0,'',0,1,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[250412037], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 2504, 2, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',2504,2,250412169,1) ;

CALL DOCLOCK_IMPORT('',0,3001,1,0,11,0,'',0,1,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[300111090], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 3001, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',3001,1,300111155,1) ;

CALL DOCLOCK_IMPORT('',0,3006,1,0,11,0,'',0,3,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[300611041], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 3006, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',3006,1,300611095,1) ;

CALL DOCLOCK_IMPORT('',0,3011,1,0,11,0,'',0,1,'',0,'         4,5 ',null,'Copy([971110006], 1, 2) = Copy(.[301111029], 4, 2)',1,'') ;

CALL DOCLOCKFIELDS_DELETE('', 3011, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('',3011,1,301111087,1) ;

DROP PROCEDURE DOCLOCK_IMPORT      
/

DROP PROCEDURE DocLockFields_InsertField
/

DROP PROCEDURE DOCLOCK_DELETE
/

DROP PROCEDURE DOCLOCKFIELDS_DELETE
/

CREATE OR REPLACE PROCEDURE LINKTYPE_DELETE(
  NAME_         VARCHAR2,
  TEMPLATECLS_  NUMBER,
  PARENTDOCCLS_ NUMBER,
  CHILDDOCCLS_  NUMBER) IS
BEGIN
  FOR tab_rec in (SELECT id FROM LINKTYPE LT
  WHERE (((NAME_ <> '') or (NAME_ is not null)) and (LT.NAME = NAME_)) or 
    (((NAME_ = '') or (NAME_ is null)) and (LT.TEMPLATECLS = TEMPLATECLS_ AND LT.PARENTDOCCLS = PARENTDOCCLS_ AND LT.CHILDDOCCLS = CHILDDOCCLS_)))    
  LOOP
    UPDATE STATE_JUMPCONTROL SET
      REFERENCEREF = NULL
    WHERE REFERENCEREF = tab_rec.id;
    DELETE FROM REPLACEMENTCLSDETAIL WHERE LINKID IN (SELECT ID FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id);
    DELETE FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id;
    DELETE FROM LINKTYPE LT
      WHERE LT.ID = tab_rec.id;
  END LOOP;     
END;
/

CREATE OR REPLACE PROCEDURE LINKTYPE_IMPORT(
   ID_                    NUMBER,
   NAME_                  VARCHAR2,
   TEMPLATECLS_           NUMBER,
   PARENTDOCCLS_          NUMBER,
   CHILDDOCCLS_           NUMBER,
   LINKCOMMENT_           VARCHAR2,
   BLOCKPARENT_           NUMBER,
   BLOCKCHILD_            NUMBER,
   CANDELBLOCKPARENT_     NUMBER,
   CANDELBLOCKCHILD_      NUMBER,
   PARENTPICTURETYPE_     NUMBER,
   PARENTPICTURENAME_     VARCHAR2,
   CHILDPICTURETYPE_      NUMBER,
   CHILDPICTURENAME_      VARCHAR2,
   PICTURECOLLECTIONNAME_ VARCHAR2,
   URMUSE_                NUMBER,
   DELMACROSNAME_         VARCHAR2,
   NEEDDELCHILD_          NUMBER,
   LINKKIND_              NUMBER
) IS
   CNT$ NUMBER(10);
BEGIN
   /*          ,     */
   /*  ,   , ,  ,     */
   IF (
   ((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0))or(Name_ is not null))   
   THEN
     FOR tab_rec in(SELECT id FROM LINKTYPE LT WHERE 
		 (id<>ID_)	
         and(((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0)and(LT.TEMPLATECLS = TEMPLATECLS_)
         and (LT.PARENTDOCCLS = PARENTDOCCLS_) and (LT.CHILDDOCCLS = CHILDDOCCLS_))
         or((Name_ is not null)and(lt.Name=Name_))))
     LOOP
        /*             */    
        DELETE FROM LINKRECORDS WHERE LINKTYPEREF = -10;  
        DELETE FROM TB_LINKTYPE WHERE ID = -10;
        DELETE FROM DOCUMENTCLS WHERE ID = -10;
        DELETE FROM DOCUMENTTYPES WHERE ID = -10;
        INSERT INTO DOCUMENTTYPES(ID, PROGINDEX) VALUES(-10, -10);
        INSERT INTO DOCUMENTCLS(ID, DOCTYPE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM)
           VALUES(-10, -10, ' ', ' ', ' ', ' ');
        INSERT INTO LINKTYPE(ID, PARENTDOCCLS, CHILDDOCCLS, NAME) VALUES(-10, -10, -10, ' ');
        UPDATE STATE_JUMPCONTROL SET
           REFERENCEREF = -10
        WHERE
           REFERENCEREF = tab_rec.id;
        UPDATE LINKRECORDS SET
           LINKTYPEREF = -10
        WHERE
           LINKTYPEREF = tab_rec.id;
        DELETE FROM TB_LINKTYPE WHERE ID = tab_rec.Id;
     END LOOP;
   end if;
   /*      */ 
   SELECT count(*) into CNT$
      FROM LINKTYPE LT WHERE LT.ID = ID_;
   IF (CNT$ = 0)    
   THEN
      INSERT INTO LINKTYPE
       (ID,NAME,TEMPLATECLS,PARENTDOCCLS, CHILDDOCCLS, LINKCOMMENT, BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,
        CANDELBLOCKCHILD, PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,
        PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND)
      VALUES
       (ID_,NAME_,TEMPLATECLS_, PARENTDOCCLS_, CHILDDOCCLS_, LINKCOMMENT_, BLOCKPARENT_,BLOCKCHILD_,CANDELBLOCKPARENT_,
        CANDELBLOCKCHILD_, PARENTPICTURETYPE_,PARENTPICTURENAME_,CHILDPICTURETYPE_,CHILDPICTURENAME_,
        PICTURECOLLECTIONNAME_,URMUSE_,DELMACROSNAME_,NEEDDELCHILD_,LINKKIND_);
   ELSE
      UPDATE LINKTYPE SET
         NAME = NAME_,
         TEMPLATECLS = TEMPLATECLS_,
         PARENTDOCCLS = PARENTDOCCLS_,
         CHILDDOCCLS = CHILDDOCCLS_,
         LINKCOMMENT = LINKCOMMENT_,
         BLOCKPARENT = BLOCKPARENT_,
         BLOCKCHILD = BLOCKCHILD_,
         CANDELBLOCKPARENT = CANDELBLOCKPARENT_,
         CANDELBLOCKCHILD = CANDELBLOCKCHILD_,
         PARENTPICTURETYPE = PARENTPICTURETYPE_,
         PARENTPICTURENAME = PARENTPICTURENAME_,
         CHILDPICTURETYPE = CHILDPICTURETYPE_,
         CHILDPICTURENAME = CHILDPICTURENAME_,
         PICTURECOLLECTIONNAME = PICTURECOLLECTIONNAME_,
         URMUSE = URMUSE_,
         DELMACROSNAME = DELMACROSNAME_,
         NEEDDELCHILD = NEEDDELCHILD_,
         LINKKIND = LINKKIND_
      WHERE ID = ID_;
   END IF;      
   
   /*      ,      */
   UPDATE STATE_JUMPCONTROL SET
     REFERENCEREF = ID_
   WHERE
     REFERENCEREF = -10;
   UPDATE LINKRECORDS SET
      LINKTYPEREF = ID_
   WHERE
      LINKTYPEREF = -10;
   /*   */  
   DELETE FROM TB_LINKTYPE WHERE ID = -10;
   DELETE FROM DOCUMENTCLS WHERE ID = -10;
   DELETE FROM DOCUMENTTYPES WHERE ID = -10;
END;
/

--  
CALL LINKTYPE_IMPORT(550311100,'___',null,550201,32500,'',0,1,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(550311200,'___',null,550201,32501,'',0,1,0,1,1,'',1,'','',0,'',1,0) ;

DROP PROCEDURE LINKTYPE_DELETE
/

DROP PROCEDURE LINKTYPE_IMPORT
/

CREATE OR REPLACE PROCEDURE STATICLINK_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATICLINKS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE STATICLINK_IMPORT(
  ID_             NUMBER,
  NAME_           VARCHAR2,
  PARENTFIELDREF_ NUMBER,
  CHILDFIELDREF_  NUMBER,
  LINKKIND_      NUMBER,
  ParentDelAction_ NUMBER
) IS
  FINDID$ NUMBER;
  FINDNEWID$ NUMBER;
  IDExists$ NUMBER;
BEGIN
  /*     ID,    CHILDFIELDREF,PARENTFIELDREF. 
   ,     ,    ID.       ID  , 
   (  )     id ,      */
  BEGIN
    SELECT
      SL.ID
    INTO FINDID$
    FROM 
      STATICLINKS SL
    WHERE (SL.CHILDFIELDREF = CHILDFIELDREF_) AND (SL.PARENTFIELDREF = PARENTFIELDREF_) AND (SL.ID <> ID_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      FINDID$ := NULL;
  END;
  
  IF (FINDID$ IS NOT NULL) THEN
  /*   ID         */

    SELECT COUNT (ID)
      INTO IDExists$
      FROM STATE_JUMPCONTROL
    WHERE (STATICLINKREF = FINDID$);

    IF (IDExists$ > 0) THEN

      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM 
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
 
      IF (FINDNEWID$ IS NULL) THEN
        INSERT INTO STATICLINKS
         (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
        VALUES
          (ID_,NAME_,CHILDFIELDREF_,PARENTFIELDREF_,1,ParentDelAction_);
      END IF;        
      UPDATE STATE_JUMPCONTROL
        SET STATICLINKREF = ID_
      WHERE (STATICLINKREF = FINDID$);

      DELETE FROM STATICLINKS  
      WHERE ID=FINDID$;
    ELSE   
      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
      IF (FINDNEWID$ IS NULL) THEN
        UPDATE STATICLINKS
        SET ID=ID_
        WHERE ID=FINDID$;
      ELSE
        DELETE FROM STATICLINKS
        WHERE ID=FINDID$;
      END IF;
    END IF;
      
  END IF; /*  id  */
  
  /*       ( ), 
   ,            CHILDFIELDREF.
   ,        1( )*/
  IF (LINKKIND_=0) THEN
    UPDATE STATICLINKS
    SET LINKKIND=1  
    WHERE (CHILDFIELDREF = CHILDFIELDREF_) AND (ID <> ID_) AND (LINKKIND=0);
  END IF;    
  
  /*        id.  ,   .  ,   */
  BEGIN
    SELECT SL.ID
      INTO FINDID$
      FROM
        STATICLINKS SL
      WHERE
        (SL.ID = ID_);
  EXCEPTION
      WHEN NO_DATA_FOUND THEN
        FINDID$ := NULL;
  END;
  IF (FINDID$ IS NOT NULL) THEN
    UPDATE STATICLINKS SET
      NAME           = NAME_,
      PARENTFIELDREF = PARENTFIELDREF_,
      CHILDFIELDREF  = CHILDFIELDREF_,
      LINKKIND       = LINKKIND_,
      ParentDelAction = ParentDelAction_
      WHERE ID = ID_;
  ELSE
    INSERT INTO STATICLINKS
     (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
    VALUES
      (ID_,NAME_,PARENTFIELDREF_,CHILDFIELDREF_,LINKKIND_,ParentDelAction_);
  END IF;      

END;
/

--  
CALL STATICLINK_IMPORT(991912500,'.1.->.ID',987910002,190011043,0,1) ;

CALL STATICLINK_IMPORT(991912400,'.1.->.ID',987910002,190001040,0,1) ;

CALL STATICLINK_IMPORT(990344700,'.AUTOSANCTION->.ID',993010001,32510137,0,0) ;

CALL STATICLINK_IMPORT(973000300,'.1.REGPROJECTRESULT->.ID',971110002,300111155,0,1) ;

CALL STATICLINK_IMPORT(973000400,'.1.REGPROJECTRESULT->.ID',971110002,300611095,0,1) ;

CALL STATICLINK_IMPORT(973000500,'.1.REGPROJECTRESULT->.ID',971110002,301111087,0,1) ;

DROP PROCEDURE STATICLINK_DELETE
/

DROP PROCEDURE STATICLINK_IMPORT
/

CREATE OR REPLACE PROCEDURE FILTERS_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATE_JUMPCONTROL
  WHERE STATE_JUMPCONTROL.FILTERCODE = ID_;
  UPDATE STATE_ACTIONJUMPS SAJ
  SET SAJ.FILTERCODE = NULL, SAJ.OPTIONS = NULL
  WHERE SAJ.FILTERCODE = ID_;
  DELETE FROM State_Filter SF
  WHERE SF.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORT(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValue_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValue,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValue_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValue = FilterValue_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORTURM(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValueURM_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValueURM,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValueURM_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValueURM = FilterValueURM_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

-- 
DROP PROCEDURE FILTERS_DELETE
/

DROP PROCEDURE FILTERS_IMPORT
/

DROP PROCEDURE FILTERS_IMPORTURM
/

CREATE OR REPLACE PROCEDURE STATUSICONS_IMPORT(
  ID_ NUMBER,
  NOTE_ VARCHAR2,
  DOCREF_ NUMBER,
  DETAILNUM_ NUMBER,
  ICONNAME_ VARCHAR2,
  ISSYSTEM_ NUMBER,
  ICONPOS_ NUMBER,
  RUNPOS_ NUMBER,
  RESERVEPOS_ NUMBER,
  ICONHINT_ VARCHAR2,
  ICONKIND_ NUMBER,
  LOCKMASK_ NUMBER,
  FORMULA_ VARCHAR2,
  ISBUDGET_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM STATUSICONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE STATUSICONS SET
      NOTE = NOTE_,
      DOCREF = DOCREF_,
      DETAILNUM = DETAILNUM_,
      ICONNAME = ICONNAME_,
      ISSYSTEM = ISSYSTEM_,
      ICONPOS = ICONPOS_,
      RUNPOS = RUNPOS_,
      RESERVEPOS = RESERVEPOS_,
      ICONHINT = ICONHINT_,
      ICONKIND = ICONKIND_,
      LOCKMASK = LOCKMASK_,
      ISBUDGET = ISBUDGET_,
      FORMULA = FORMULA_
    WHERE ID = ID_;
  ELSE
    INSERT INTO STATUSICONS
      (ISBUDGET, ID, NOTE, DOCREF, DETAILNUM, ICONNAME, ISSYSTEM, ICONPOS, RUNPOS, RESERVEPOS, ICONHINT, ICONKIND, LOCKMASK, FORMULA)
    VALUES
      (ISBUDGET_, ID_, NOTE_, DOCREF_, DETAILNUM_, ICONNAME_, ISSYSTEM_, ICONPOS_, RUNPOS_, RESERVEPOS_, ICONHINT_, ICONKIND_, LOCKMASK_, FORMULA_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE STATUSICONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM STATUSICONS SI
  WHERE SI.ID = ID_;
END;
/

--  
DROP PROCEDURE STATUSICONS_IMPORT
/

DROP PROCEDURE STATUSICONS_DELETE
/


CREATE OR REPLACE PROCEDURE ENUMS_IMPORT(NAME_ VARCHAR2,FACIALACCCLS_ NUMBER) IS
  IDEXISTS$ NUMBER;
BEGIN
  SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMS WHERE NAME = NAME_;
  IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMS E1
      WHERE (E1.NAME = NAME_) AND (E1.ID > (SELECT MIN(E2.ID) FROM ENUMS E2 WHERE E2.NAME = NAME_));
  END IF;
  IF (IDEXISTS$ > 0) THEN
    UPDATE ENUMS SET
      FACIALACCCLS = FACIALACCCLS_,
      ISSYSTEM = 1
    WHERE NAME = NAME_;
  ELSE
    INSERT INTO ENUMS
      (NAME,FACIALACCCLS,ISSYSTEM)    
    VALUES
      (NAME_,FACIALACCCLS_,1);
  END IF;    
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_IMPORT(ENUMNAME_ VARCHAR2,NAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
  IDEXISTS$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      IDENUM$ := NULL;
  END;  
  IF (IDENUM$ IS NOT NULL) THEN
    SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMVALUES WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMVALUES EV1
      WHERE (EV1.ENUMREF = IDENUM$) AND (EV1.VAL = VAL_) AND
        (EV1.ID > (SELECT MIN(EV2.ID) FROM ENUMVALUES EV2 WHERE EV2.ENUMREF = IDENUM$ AND EV2.VAL = VAL_));
    END IF;
    IF (IDEXISTS$ > 0) THEN
      UPDATE ENUMVALUES SET
        NAME = NAME_
      WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    ELSE
      INSERT INTO ENUMVALUES
        (VAL,NAME,ENUMREF)  
      VALUES
        (VAL_,NAME_,IDENUM$);
    END IF;    
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE ENUMS_DELETE(NAME_ VARCHAR2) IS
BEGIN
  DELETE FROM ENUMS WHERE NAME = NAME_;
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_DELETE(ENUMNAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
     WHEN NO_DATA_FOUND THEN
       IDENUM$ := NULL;  
  END;
  IF (IDENUM$ IS NOT NULL) THEN
    DELETE FROM ENUMVALUES WHERE (VAL = VAL_) AND (ENUMREF = IDENUM$);
  END IF;  
END;
/

-- 
CALL ENUMVALUES_IMPORT('','  ',23) ;

CALL ENUMVALUES_IMPORT('','   ()',32) ;

CALL ENUMVALUES_IMPORT('','  ()',41) ;

CALL ENUMVALUES_IMPORT('','  ',45) ;

CALL ENUMVALUES_IMPORT('',' ',57) ;

CALL ENUMVALUES_IMPORT('','  ',62) ;

CALL ENUMVALUES_IMPORT('',' ',67) ;

CALL ENUMVALUES_IMPORT('','   ',68) ;

CALL ENUMVALUES_IMPORT('','    ',69) ;

CALL ENUMVALUES_IMPORT('','   ',70) ;

CALL ENUMVALUES_IMPORT('','     ',71) ;

CALL ENUMVALUES_IMPORT('',' ',274) ;

CALL ENUMVALUES_IMPORT('','   ()',215) ;

CALL ENUMVALUES_IMPORT('','',222) ;

CALL ENUMVALUES_IMPORT('','   ',223) ;

CALL ENUMVALUES_IMPORT('','   ',230) ;

CALL ENUMVALUES_IMPORT('',' ',252) ;

CALL ENUMVALUES_IMPORT('',' ()',260) ;

CALL ENUMVALUES_IMPORT('',' , ',262) ;

CALL ENUMVALUES_IMPORT('','',263) ;

CALL ENUMVALUES_IMPORT('',' ()',264) ;

CALL ENUMVALUES_IMPORT('','   ()',268) ;

CALL ENUMVALUES_IMPORT('','   ()',271) ;

CALL ENUMVALUES_IMPORT('','  ',272) ;

CALL ENUMVALUES_IMPORT('','   ',273) ;

CALL ENUMVALUES_IMPORT('',' ',304) ;

CALL ENUMVALUES_IMPORT('',' ',305) ;

CALL ENUMVALUES_IMPORT('','  ',308) ;

CALL ENUMVALUES_IMPORT('','   ',312) ;

CALL ENUMVALUES_IMPORT('',' ',314) ;

CALL ENUMVALUES_IMPORT('','   ',313) ;

CALL ENUMVALUES_IMPORT('','   ',525) ;

CALL ENUMVALUES_IMPORT('','    223-',241) ;

CALL ENUMVALUES_IMPORT('','   223-',240) ;

CALL ENUMVALUES_IMPORT('','- ',242) ;

CALL ENUMVALUES_IMPORT('',' - ',243) ;

CALL ENUMVALUES_IMPORT('',' ',527) ;

CALL ENUMVALUES_IMPORT('','   ',283) ;

CALL ENUMVALUES_IMPORT('',' ',275) ;

CALL ENUMVALUES_IMPORT('','  , ',276) ;

CALL ENUMVALUES_IMPORT('','     ',277) ;

CALL ENUMVALUES_IMPORT('','  14 /',278) ;

CALL ENUMVALUES_IMPORT('','  14 /',279) ;

CALL ENUMVALUES_IMPORT('','   ',280) ;

CALL ENUMVALUES_IMPORT('','   ',281) ;

CALL ENUMVALUES_IMPORT('',' ',282) ;

CALL ENUMVALUES_IMPORT('',' ',521) ;

CALL ENUMVALUES_IMPORT('',' ',234) ;

CALL ENUMVALUES_IMPORT('','  ',550) ;

CALL ENUMVALUES_IMPORT('',' ',235) ;

CALL ENUMVALUES_IMPORT('',' ',528) ;

CALL ENUMVALUES_IMPORT('',' ',526) ;

CALL ENUMVALUES_IMPORT('',' ( )',112) ;

CALL ENUMVALUES_IMPORT('',' / ',556) ;

CALL ENUMVALUES_IMPORT('','  ',560) ;

CALL ENUMVALUES_IMPORT('',' ',5) ;

DROP PROCEDURE ENUMS_IMPORT
/

DROP PROCEDURE ENUMVALUES_IMPORT
/

DROP PROCEDURE ENUMS_DELETE
/

DROP PROCEDURE ENUMVALUES_DELETE
/

--      
INSERT INTO DFUCHANGELOG (VersionID, BEGINUPDATECODE, ENDUPDATECODE, LASTUPDATEDFU, ISBUDGET, INCLUDEDEL, INCLUDEBLOCKS, INCLUDEDOCS, SCRIPTCREATOR, SCRIPTCREATEDATE, NOTE) VALUES (3840, 143000, 143000, TO_DATE('22.02.2022 14:48:57', 'DD.MM.YYYY HH24:MI:SS'), 2, 1, ',    ,  , ,  , ,  , , ', '00.00, 01.01, 02.00, 02.01, 02.02, 02.03, 02.04, 02.05, 02.06, 02.07, 02.08, 02.09, 02.10, 02.11, 02.12, 02.13, 02.14, 02.15, 02.16, 02.17, 02.18, 03.00, 03.01, 03.02, 03.03, 03.04, 03.05, 03.06, 03.07, 03.08, 03.11, 03.12, 03.14, 03.15, 03.16, 03.22, 03.23, 03.24, 03.25, 04.01, 05.01, 07.01, 07.02, 07.03, 08.01, 08.02, 08.03, 08.04, 09.00, 09.01, 09.02, 09.03, 09.05, 09.06, 09.07, 12.01, 15.01, 16.01, 16.02, 17.01, 17.02, 18.05, 18.07, 18.09, 18.10, 18.12, 18.13, 18.14, 18.15, 18.16, 18.18, 18.19, 18.20, 18.21, 18.24, 18.25, 19.00, 19.01, 19.02, 19.03, 19.06, 22.00, 22.01, 25.01, 25.02, 25.03, 25.04, 28.01, 28.02, 30.01, 30.02, 30.03, 30.04, 30.05, 30.06, 30.10, 30.11, 36.10, 37.01, 39.01, 44.01, 44.03, 47.01, 48.01, 49.01, 49.02, 49.03, 51.01, 52.01, 53.01, 53.02, 53.03, 53.04, 53.05, 53.06, 54.01, 54.02, 55.01, 55.02, 55.03, 56.01, 96.01, 96.02, 96.03, 96.04, 97.01, 97.02, 97.09, 97.10, 97.11, 97.12, 97.13, 97.14, 97.16, 98.02, 98.03, 98.04, 98.05, 98.06, 98.08, 98.09, 98.10, 98.11, 98.12, 98.13, 98.14, 98.15, 98.16, 98.17, 98.18, 98.20, 98.21, 98.22, 98.23, 98.26, 98.27, 98.28, 98.29, 98.34, 98.35, 98.41, 98.42, 98.43, 98.44, 98.45, 98.46, 98.47, 98.48, 98.49, 98.50, 98.51, 98.52, 98.53, 98.54, 98.57, 98.58, 98.59, 98.60, 98.61, 98.62, 98.63, 98.64, 98.65, 98.67, 98.68, 98.69, 98.70, 98.71, 98.72, 98.78, 98.79, 98.80, 98.81, 98.82, 98.83, 98.84, 98.85, 98.86, 98.87, 98.88, 98.89, 98.90, 98.91, 98.92, 98.94, 98.95, 98.97, 98.98, 98.99, 99.03, 99.04, 99.05, 99.08, 99.12, 99.13, 99.14, 99.15, 99.16, 99.17, 99.18, 99.19, 99.20, 99.21, 99.22, 99.23, 99.24, 99.25, 99.26, 99.27, 99.28, 99.29, 99.30, 99.31, 99.32, 99.33, 99.34, 99.35, 99.36', 'MKOPACHEV/belorusova', TO_DATE('22.02.2022 14:49:40', 'DD.MM.YYYY HH24:MI:SS'), '') ;

COMMIT WORK
/




-- #########################################################
-- #########################################################
-- DBVersion.sql
-- #########################################################
-- #########################################################

INSERT INTO DataBaseVersion(VERSION, Major, Minor, AComment)
  VALUES ('14.30.00', 1430, 00, ' 14.30.00')
/

COMMIT WORK
/

-- #########################################################
-- #########################################################
-- Index_Fix.sql
-- #########################################################
-- #########################################################

--      INDX
DECLARE
  CURSOR C$ IS
    select INDEX_NAME from DBA_INDEXES
    where OWNER = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      and TABLESPACE_NAME <> 'INDX'
      and INDEX_TYPE LIKE '%NORMAL%';
  CNT$ NUMBER(10);    
BEGIN
  BEGIN
    select count(*) into CNT$ from V$TABLESPACE
    where name = 'INDX';
  EXCEPTION
    WHEN OTHERS THEN
      CNT$ := 1;
  END;
  IF CNT$ = 1 THEN
    FOR R$ IN C$ LOOP
      EXECUTE IMMEDIATE 'ALTER INDEX ' || R$.INDEX_NAME || ' REBUILD TABLESPACE INDX';
    END LOOP;
  END IF;
END;
/

-- #########################################################
-- #########################################################
-- compile_scr.sql
-- #########################################################
-- #########################################################

--      , 
--  -  
--  DBMS_UTILITY.COMPILE_SCHEMA(user, TRUE);

DECLARE
  CURSOR C$ IS
    SELECT 'ALTER ' || object_type || ' ' || owner || '.' || object_name || ' COMPILE' AS str,
      object_type, object_name
    FROM SYS.ALL_OBJECTS
    WHERE owner = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      AND object_type IN ('VIEW', 'PROCEDURE', 'TRIGGER')
      AND status = 'INVALID'
      AND object_name not like 'BIN$%'
    ORDER BY DECODE(object_type, 'VIEW', 1, 'PROCEDURE', 2, 'TRIGGER', 3), object_name;
  S VARCHAR2(100);
BEGIN
  FOR R$ IN C$ LOOP
    BEGIN
      S := R$.object_type || ' ' || R$.object_name;
      EXECUTE IMMEDIATE R$.str;
    EXCEPTION
      WHEN OTHERS THEN 
        --DBMS_OUTPUT.PUT_LINE(S);
        RAISE_APPLICATION_ERROR(-20000, '    ' || S);
    END;
  END LOOP;
END;
/

-- #########################################################
-- #########################################################
-- dbms_stats_scr.sql
-- #########################################################
-- #########################################################

ALTER SESSION SET NLS_NUMERIC_CHARACTERS='.,'
/

BEGIN
  DBMS_STATS.GATHER_SCHEMA_STATS(
    SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA'),
    DBMS_STATS.AUTO_SAMPLE_SIZE,
    false,
    'FOR ALL COLUMNS SIZE AUTO',
    cascade=>TRUE
  );
END;
/

exit
